/*
 * $Log: menusubs.c,v $
 * Revision 1.1  1995/09/16 17:22:18  root
 * Initial login under Linux
 *
 * Revision 1.3  1995/03/31  12:21:52  jrh
 * Fix mallocs to use xmalloc
 *
 * Revision 1.2  1995/03/12  23:00:08  jrh
 * scripting
 *
 * Revision 1.1  1994/05/30  21:43:43  jrh
 * Initial checkin at v1.33
 *
 */

static char rcsid[] ="$Id: menusubs.c,v 1.1 1995/09/16 17:22:18 root Exp $";

#include <stdio.h>
#include <qdos.h>
#include <qptr.h>

#include "defs.h"

extern int QPTR_VERS;

Prototype void LoadMenu (struct WM_menw *, PLLIST, struct WM_action *);

void LoadMenu (struct WM_menw *menu, PLLIST list, struct WM_action *act)
{
    int i;
    struct WM_rowl *rowl;
    struct WM_mobj *mobj;
    char *mstt;
    PLLIST p;
    int nitem;
    int nsize;
 
    for (p = list, nitem = 0; p; p = p->next, nitem++)
	;			/* NULL LOOP to find nitems */

    if (menu->rowl)
    {
	xfree (menu->rowl);
    }

    menu->rowl = NULL;
    menu->ncol = 1;
    menu->nrow = nitem;


    nsize = (sizeof (struct WM_rowl) + sizeof (struct WM_mobj) + 
                             sizeof (struct WM_mobj) + 1) * nitem;


    menu->rowl =       /* allocate all working space in a lump */
    rowl = (struct WM_rowl *) xmalloc
      ((int)((sizeof(struct WM_rowl) + sizeof(struct WM_mobj) + 1) * nitem));
    mobj = (struct WM_mobj *)
          (((char *) rowl) + sizeof(struct WM_rowl) * nitem);
    menu->mstt =
    mstt = ((char *) mobj) + sizeof(struct WM_mobj) * nitem;

    for (i = 0; i < nitem; i++)	/* initialise menu structures */
    {
	mobj->xjst = 1;
	mobj->yjst = 0;
	mobj->type = 0;
	mobj->skey = 0;
	mobj->pobj = (char *) ((PMDEF) list->item)->qtext;
	mobj->item = i;
	if (((PMDEF) list->item)->action == NULL)
	{
	    mobj->pact = act;
	}
	else
	{
	    mobj->pact = ((PMDEF) list->item)->action;
	}
	if (((PMDEF) list->item)->skey > 0)
	{
	    mobj->skey = ((PMDEF) list->item)->skey;
	}
	else if (((PMDEF) list->item)->skey < 0)
	{
            mobj->type += ((PMDEF) list->item)->skey;
	    mobj->skey = *(((struct QD_text *) mobj->pobj)->chrs
			   - (((PMDEF) list->item)->skey + 1));
	    if (mobj->skey > 'Z')
	    {
		mobj->skey -= ' ';
	    }
	}

	rowl->rows = mobj++;	/* one object per row */
	(rowl++)->rowe = mobj;
	*(mstt++) = ((PMDEF) list->item)->status;
	list = list->next;	/* next text */
    }
}
