/*
 * $Log: qdsetup.c,v $
 * Revision 1.2  1995/11/12 15:29:37  root
 * Baud rates for different O/S
 *
 * Revision 1.1  1995/09/16  17:22:18  root
 * Initial login under Linux
 *
 * Revision 1.2  1995/03/12  23:00:08  jrh
 * scripting
 *
 * Revision 1.1  1994/05/30  21:43:26  jrh
 * Initial checkin at v1.33
 *
 */

static char rcsid[] ="$Id: qdsetup.c,v 1.2 1995/11/12 15:29:37 root Exp $";

#include <stdio.h>
#include <qdos.h>
#include <qptr.h>

typedef struct QD_text QDS, *PQDS;

#include "defs.h"

Prototype SLoad_Setup ();
Prototype SLoad_Flags (PPHONE_LIST);
Prototype SetText (PEDITLIST, PPHONE_LIST);
Prototype UnloadSer (PPHONE_LIST);
Prototype ConfigSer (PPHONE_LIST);
Prototype char *OptText (PPHONE_LIST, int, int);

LOCAL char Sxlate[] = {SET_EMUL, SET_RX_EOL, SET_TX_EOL, SET_DELC, SET_KEY1};

LOCAL char Oxlate[] = {SET_EMUL, SET_BAUD, SET_PARI,
 SET_FLOW, SET_RX_EOL, SET_TX_EOL, SET_DELC, SET_KEY1};

LOCAL char oflags[] = {0, 10, 11, 12, 7, 8, 9, 13};
LOCAL char sflags[] = {0, 4, 3, 5, 1, 2, 6, 7, 8, 9, 10};


SLoad_Setup ()
{
    int i;

    for (i = 0; i < MAX_OXL; i++)
    {
	DialOpts[DX_EMUL + i].current = Setups[Oxlate[i]].current;
    }
}

SLoad_Flags (PPHONE_LIST pItem)
{
    int i;

    for (i = 0; i < MAX_OXL; i++)
    {
	DialOpts[DX_EMUL + i].current = pItem->Flags[oflags[i]];
    }
}
SetText (PEDITLIST p, PPHONE_LIST pItem)
{
    (p + DL_NAME)->list = (void *) pItem->Name;
    (p + DL_PNO)->list = (void *) pItem->Phone;
    (p + DL_LOG)->list = (void *) pItem->Logon;
    (p + DL_LOG2)->list = (void *) pItem->Logon2;
    (p + DL_COM)->list = (void *) pItem->Comment;
    (p + DL_MDM)->list = (void *) pItem->Modem;
    (p + DL_PRCL)->list = (void *) pItem->Protocol;
}

UnloadSer (PPHONE_LIST pItem)
{
    int i;

    for (i = 0; i < MAX_OXL; i++)
    {
	pItem->Flags[oflags[i]] = DialOpts[DX_EMUL + i].current;
    }
}

ConfigSer (PPHONE_LIST pItem)
{
    int i;

    for (i = 0; i < MAX_OXL; i++)
    {
	if (Oxlate[i] != SET_BAUD ||
	  (Oxlate[i] == SET_BAUD && pItem->Flags[oflags[i]] <= lbaud))
	{
	    if (Setups[Oxlate[i]].current != pItem->Flags[oflags[i]])
	    {
		Setups[Oxlate[i]].current = pItem->Flags[oflags[i]];
		Setups[Oxlate[i]].Change = TRUE;
	    }
	}
    }
}
char *OptText (PPHONE_LIST pItem, int qflag, int item)
{
    PEDITLIST pEd;
    POPTLIST pOpt;
    char *s;

    pEd = (qflag) ?
	(Setups + Sxlate[item]) : (Setups + Oxlate[item]);
    pOpt = (POPTLIST) pEd->list;
    pOpt += (qflag) ?
	pItem->Flags[sflags[item]] : pItem->Flags[oflags[item]];

    s = (char *) ((PQDS) pOpt->Text)->chrs;
    return s;
}


