/*
 * $Log: qsdata.c,v $
 * Revision 1.8  1997/08/23 21:13:39  jrh
 * pre config removal
 *
 * Revision 1.7  1997/01/04 23:16:13  jrh
 * 1.62 release version
 *
 * Revision 1.6  1996/12/23 22:32:56  jrh
 * Checkin for 1.62
 *
 * Revision 1.5  1996/07/09  12:25:57  jrh
 * post fsel (1.60)
 *
 * Revision 1.4  1996/07/09  09:26:14  jrh
 * pre file sel (1.599)
 *
 * Revision 1.3  1995/12/30  18:28:09  root
 * For v1.57 (QXL baud, SH status, CSM crash)
 *
 * Revision 1.2  1995/11/12  15:29:37  root
 * Baud rates for different O/S
 *
 * Revision 1.1  1995/09/16  17:22:18  root
 * Initial login under Linux
 *
 * Revision 1.11  1995/05/31  17:05:26  jrh
 * No CR option and new XPR (nothing)
 *
 * Revision 1.10  1995/03/31  21:21:23  jrh
 * Add User menu code and icon
 *
 * Revision 1.9  1995/03/18  12:34:53  jrh
 * preparation for Viewdata
 *
 * Revision 1.8  1995/03/13  22:13:34  jrh
 * Added init/exit scripting
 *
 * Revision 1.7  1995/03/12  23:00:08  jrh
 * scripting
 *
 * Revision 1.6  1994/12/15  21:31:12  jrh
 * delay changes
 *
 * Revision 1.5  1994/07/09  15:34:29  jrh
 * Add force for VT wrap
 *
 * Revision 1.4  1994/06/09  16:21:47  jrh
 * Add generic text messages
 *
 * Revision 1.3  1994/06/05  19:10:16  jrh
 * Added VT100/Vt102 options
 *
 * Revision 1.2  1994/05/31  22:19:55  jrh
 * Additional options for connect options
 *
 * Revision 1.1  1994/05/30  21:43:11  jrh
 * Initial checkin at v1.33
 *
 */

static char rcsid[] ="$Id: qsdata.c,v 1.8 1997/08/23 21:13:39 jrh Exp $";

#include <stdio.h>
#include <qdos.h>
#include <qlib.h>
#include <qptr.h>
#include <stdlib.h>
#include "qtpptr.h"
#include "qem.h"
#include "qstr.h"
#include <string.h>

static QD_TEXTI (tx01, "Off");
static QD_TEXTI (tx02, "On");
static QD_TEXTI (tx02a, "Force");

OPTLIST stWrap[] =
{
    {&tx01, 0},
    {&tx02, 1},
    {&tx02a, 2},
    NULL};

static QD_TEXTI (tx03, "VT52");
static QD_TEXTI (tx04, "VT100");
static QD_TEXTI (tx04a, "VT102");
static QD_TEXTI (tx05, "ANSI1");
static QD_TEXTI (tx06, "ANSI2");
static QD_TEXTI (tx07, "ANSI3");
static QD_TEXTI (tx08, "ANSI4");
#ifdef VDATA
static QD_TEXTI (tx08a,"VIEWData");
#endif

OPTLIST stVt[] =
{
    {&tx03, VT52},
    {&tx04, VT100},
    {&tx04a, VT102},
    {&tx05, ANSI1},
    {&tx06, ANSI2},
    {&tx07, ANSI3},
    {&tx08, ANSI4},
#ifdef VDATA
    {&tx08a,VIEWD},
#endif
    NULL};


#define DYNASER 1

#ifdef DYNASER
OPTLIST stPort[9] = {0};
#else
static QD_TEXTI (tx09, "ser2");
static QD_TEXTI (tx10, "ser1");

OPTLIST stPort[] =
{
    {&tx09, '2'},
    {&tx10, '1'},
    NULL
};
#endif

static QD_TEXTI (tx11, "None");
static QD_TEXTI (tx12, "Even");
static QD_TEXTI (tx13, "Odd");
static QD_TEXTI (tx14, "Space");
static QD_TEXTI (tx15, "Mark");
static QD_TEXTI (tx80, "CIS");

OPTLIST stParity[] =
{
    {&tx11, 0},
    {&tx12, 'e'},
    {&tx13, 'o'},
    {&tx14, 's'},
    {&tx15, 'm'},
    {&tx80, 'C'},
    NULL};

static QD_TEXTI (tx16, "Handshake");
static QD_TEXTI (tx17, "Ignore");

OPTLIST stShake[] =
{
    {&tx16, 'h'},
    {&tx17, 'i'},
    NULL};

static QD_TEXTI (tx18, "Raw Data");
static QD_TEXTI (tx19, "Control Z");
static QD_TEXTI (tx20, "CR xlate");

OPTLIST stProt[] =
{
    {&tx18, 'r'},
    {&tx19, 'z'},
    {&tx20, 'c'},
    NULL};

static QD_TEXTI (tx21, "75");
static QD_TEXTI (tx22, "300");
static QD_TEXTI (tx23, "600");
static QD_TEXTI (tx24, "1200");
static QD_TEXTI (tx25, "2400");
static QD_TEXTI (tx26, "4800");
static QD_TEXTI (tx27, "9600");
static QD_TEXTI (tx28, "19200");
static QD_TEXTI (tx28a, "38400");
static QD_TEXTI (tx28b, "57600");
static QD_TEXTI (tx29, "None");
static QD_TEXTI (tx29a, "Never");

OPTLIST stSpeed[] =
{
    {&tx21, 75},
    {&tx22, 300},
    {&tx23, 600},
    {&tx24, 1200},
    {&tx25, 2400},
    {&tx26, 4800},
    {&tx27, 9600},
    {&tx28, 19200},
#define BAUD19200 7
    {&tx28a, 38400},
    {&tx28b, 57600},
#define BAUD57600 9
    {&tx29, 0},
    NULL};

OPTLIST stExSpeed[] =
{
    {&tx21, 75},
    {&tx22, 300},
    {&tx23, 600},
    {&tx24, 1200},
    {&tx25, 2400},
    {&tx26, 4800},
    {&tx27, 9600},
    {&tx28, 19200},
    {&tx28a, 38400},
    {&tx28b, 57600},
    {&tx29, 0},
    {&tx29a, -1},
    NULL};

static QD_TEXTI (tx30, "On Line");
static QD_TEXTI (tx31, "Local");
static QD_TEXTI (tx32, "Echo");

OPTLIST stMode[] =
{
    {&tx30, 0},
    {&tx31, 1},
    {&tx32, 2},
    NULL};

static QD_TEXTI (tx33, "<LF>");
static QD_TEXTI (tx34, "<CR>");
static QD_TEXTI (tx35, "<CR/LF>");

OPTLIST stCRLF[] =
{
    {&tx33, EOLLF},
    {&tx34, EOLCR},
    {&tx35, EOLCRLF},
    NULL};

static QD_TEXTI (tx38, "On Line");
static QD_TEXTI (tx39, "Not used");

static QD_TEXTI (tx47, "1 Stop bit");
static QD_TEXTI (tx48, "2 Stop bits");

OPTLIST stStop[] =
{
    {&tx47, 64},
    {&tx48, 192},
    NULL};

static QD_TEXTI (tx56, "^C");
static QD_TEXTI (tx57, "^V");
static QD_TEXTI (tx58, "Shift ^C");

OPTLIST stSwap[] =
{
    {&tx56, 3},
    {&tx57, 22},
    {&tx58, 163},
    NULL};

static QD_TEXTI (tx59, "Yes");
static QD_TEXTI (tx60, "No");

OPTLIST stYesNo[] =
{
    {&tx59, 1},
    {&tx60, 0},
    NULL};

static QD_TEXTI (tx61, "Interpret");
static QD_TEXTI (tx62, "Display");

OPTLIST stCtrl[] =
{
    {&tx61, 0},
    {&tx62, 1},
    NULL};

static QD_TEXTI (tx63, "DEL (127)");
static QD_TEXTI (tx64, "BS (8)");

OPTLIST stDelC[] =
{
    {&tx63, 127},
    {&tx64, 8},
    NULL};

static QD_TEXTI (tx67, "Move Pointer");
static QD_TEXTI (tx68, "As Keys");

OPTLIST stArrows[] =
{
    {&tx67, 0},
    {&tx68, 1},
    NULL
};

static QD_TEXTI (tx74, "Redraw");
static QD_TEXTI (tx75, "Clear");

OPTLIST stRedraw[] =
{
    {&tx74, 1},
    {&tx75, 0},
    NULL
};

static QD_TEXTI (tx69, "Full Screen");
static QD_TEXTI (tx70, "Iconified");
static QD_TEXTI (tx73, "Info Icon");

OPTLIST stXPR[] =
{
    {&tx69, 0},
    {&tx70, 1},
    {&tx73, 3},
    NULL
};

static QD_TEXTI (ht00, "Emulation");
static QD_TEXTI (ht01, "Port");
static QD_TEXTI (ht02, "Parity");
static QD_TEXTI (ht03, "Flow");
static QD_TEXTI (ht04, "Translate");
static QD_TEXTI (ht05, "Baud");
static QD_TEXTI (ht06, "RX EOL");
static QD_TEXTI (ht07, "TX EOL");
static QD_TEXTI (ht08, "Del Char");
static QD_TEXTI (ht09, "VT Wrap");
static QD_TEXTI (ht10, "XPR Protocol");
static QD_TEXTI (ht11, "Modem");

/* 13 is also QConnect */
static QD_TEXTI (ht14, "Job Swap");
static QD_TEXTI (ht15, "Xon/Xoff");
static QD_TEXTI (ht16, "Controls");
static QD_TEXTI (ht17, "Exit Baud");
static QD_TEXTI (ht18, "Access");
static QD_TEXTI (ht19, "Scroll");
static QD_TEXTI (ht20, "Dial Try");
static QD_TEXTI (ht21, "Dial Wait");
static QD_TEXTI (ht22, "Comm Dev");
static QD_TEXTI (ht24, "Apr\203s Dial");
static QD_TEXTI (ht25, "Libr Dir");
static QD_TEXTI (ht26, "Modem Init");
static QD_TEXTI (ht27, "Pre Dial");
static QD_TEXTI (ht28, "Post Dial");

static QD_TEXTI (ht40, "Beep");
static QD_TEXTI (ht41, "CSI");
static QD_TEXTI (ht42, "Cmd Delay");
static QD_TEXTI (ht43, "Ser Buffer");
static QD_TEXTI (ht44, "Arrow Keys");
static QD_TEXTI (ht45, "Start XPR");

static QD_TEXTI (ht50, "VT KeyPad");
static QD_TEXTI (ht51, "On Wake");
static QD_TEXTI (ht52, "CR in log");
static QD_TEXTI (ht53, "7bit keys");
static QD_TEXTI (ht54, "One Liner");
static QD_TEXTI (ht55, "Xfer Signoff");

EDITLIST Setups[] =
{
    {&ht00, (void *) stVt, 1, 0, 1, TOGGLE, 0, 0},
    {&ht01, (void *) stPort, 0, 0, 0, TOGGLE, 0, 1},
    {&ht02, (void *) stParity, 0, 0, 0, TOGGLE, 0, 2},
    {&ht03, (void *) stShake, 0, 0, 0, TOGGLE, 0, 3},
    {&ht04, (void *) stProt, 0, 0, 0, TOGGLE, 0, 4},
    {&ht05, (void *) stSpeed, 6, 0, 6, TOGGLE, 0, 5},
    {&ht06, (void *) stCRLF, 2, 0, 2, TOGGLE, 0, 6},
    {&ht07, (void *) stCRLF, 2, 0, 2, TOGGLE, 0, 7},
    {&ht08, (void *) stDelC, 0, 0, 0, TOGGLE, 0, 8},
    {&ht09, (void *) stWrap, 1, 0, 1, TOGGLE, 0, 9},
    {&ht10, (void *) MyProtocol, 0, 0, 15, XEDIT, 0, 10},
    {&ht40, (void *) stWrap, 0, 0, 0, TOGGLE, 0, 11},
    {&ht41, (void *) stCtrl, 0, 0, 0, TOGGLE, 0, 12},
    {&ht44, (void *) stArrows,1, 0,  1, TOGGLE, 0, 13},
    {&ht53, (void *) stYesNo, 1, 0, 1, TOGGLE, 0, 14},
    {&ht50, (void *) stYesNo, 0, 0, 0, TOGGLE, 1, 0},
    {&ht14, (void *) stSwap, 0, 0, 0, TOGGLE, 1, 1},
    {&ht15, (void *) stYesNo, 0, 0, 0, TOGGLE, 1, 2},
    {&ht16, (void *) stCtrl, 0, 0, 0, TOGGLE, 1, 3},
    {&ht17, (void *) stExSpeed, 6, 0, 6, TOGGLE, 1, 4},
    {&ht18, (void *) stMode, 0, 0, 0, TOGGLE, 1, 5},
    {&ht19, (void *) TScroll, 0, 0, 8, EDIT, 1, 6},
    {&ht20, (void *) DtxtTry, 0, 0, 8, EDIT, 1, 7},
    {&ht21, (void *) DtxtWait, 0, 0, 8, EDIT, 1, 8},
    {&ht42, (void *) CmdDel, 0, 0, 8, EDIT, 1, 9},
    {&ht43, (void *) DBuffer, 0, 0, 8, EDIT, 1, 10},
    {&ht45, (void *) stXPR, 0, 0, 0, TOGGLE, 1, 11},
    {&ht51, (void *) stRedraw, 0, 0, 0, TOGGLE, 1, 12},
    {&ht52, (void *) stYesNo, 0, 0, 0, TOGGLE, 1, 13},
    {&ht54, (void *) OBuffer, 0, 0, 8, EDIT, 1, 14},
    {&ht55, (void *) ZBuffer, 0, 0, 8, EDIT, 0, 15},
    {&ht22, (void *) ComDev, 0, 0, 39, EDIT, 0, 16},
    NULL};

static QD_TEXTI (dt00, "Name");
static QD_TEXTI (dt01, "Phone No");
static QD_TEXTI (dt02, "Logon");
static QD_TEXTI (dt03, "Logon++");
static QD_TEXTI (dt04, "Comment");
static QD_TEXTI (dt05, "Modem Ini");

EDITLIST DialOpts[] =
{
    {&dt00, (void *) NULL, 0, 0, 31, EDIT, 0, 0},
    {&dt01, (void *) NULL, 0, 0, 39, EDIT, 0, 1},
    {&dt02, (void *) NULL, 0, 0, 39, EDIT, 0, 2},
    {&dt03, (void *) NULL, 0, 0, 39, EDIT, 0, 3},
    {&dt04, (void *) NULL, 0, 0, 39, EDIT, 0, 4},
    {&dt05, (void *) NULL, 0, 0, 31, EDIT, 0, 5},
    {&ht10, (void *) MyProtocol, 0, 0, 15, XEDIT, 0, 6},
    {&ht00, (void *) stVt, 0, 0, 0, TOGGLE, 0, 8},
    {&ht05, (void *) stSpeed, 0, 0, 0, TOGGLE, 0, 9},
    {&ht02, (void *) stParity, 0, 0, 0, TOGGLE, 0, 10},
    {&ht03, (void *) stShake, 0, 0, 0, TOGGLE, 0, 11},
    {&ht06, (void *) stCRLF, 0, 0, 0, TOGGLE, 1, 8},
    {&ht07, (void *) stCRLF, 0, 0, 0, TOGGLE, 1, 9},
    {&ht08, (void *) stDelC, 0, 0, 0, TOGGLE, 1, 10},
    {&ht53, (void *) stYesNo, 1, 0, 1, TOGGLE, 1, 11},
    NULL};

static QD_TEXTI (md00, "Disconnect");
static QD_TEXTI (md01, "Connect");
static QD_TEXTI (md02, "Answer");
static QD_TEXTI (md03, "AutoAnswer");
static QD_TEXTI (md04, "Reset");
static QD_TEXTI (md05, "Version");
static QD_TEXTI (md06, "Get carrier");
static QD_TEXTI (md07, "Drop carrier");

EDITLIST ModemSetups[] =
{
    {&ht26, (void *) ModemIni, 0, 0, 39, EDIT, 0, 0},
    {&ht27, (void *) PreDial, 0, 0, 39, EDIT, 0, 1},
    {&ht28, (void *) PostDial, 0, 0, 39, EDIT, 0, 2},
    {&ht24, (void *) ApresDial, 0, 0, 39, EDIT, 0, 4},
    {&md00, (void *) MdmCtrl[0], 0, 0, 31, EDIT, 0, 5},
    {&md01, (void *) MdmCtrl[1], 0, 0, 31, EDIT, 0, 6},
    {&md02, (void *) MdmCtrl[2], 0, 0, 31, EDIT, 0, 7},
    {&md03, (void *) MdmCtrl[3], 0, 0, 31, EDIT, 0, 8},
    {&md04, (void *) MdmCtrl[4], 0, 0, 31, EDIT, 0, 9},
    {&md05, (void *) MdmCtrl[5], 0, 0, 31, EDIT, 0, 10},
    {&md06, (void *) MdmCtrl[6], 0, 0, 31, EDIT, 0, 11},
    {&md07, (void *) MdmCtrl[7], 0, 0, 31, EDIT, 0, 12},
    NULL
};

static QD_TEXTI (ft01, "Phone Book");
static QD_TEXTI (ft02, "UpLoad path");
static QD_TEXTI (ft03, "DownLoad path");
static QD_TEXTI (ft04, "Send From");
static QD_TEXTI (ft05, "Receive To");
static QD_TEXTI (ft06, "Hot Keys");
static QD_TEXTI (ht23, "Default Log");
static QD_TEXTI (ft07, "Start with");
static QD_TEXTI (ft08, "Script Log");
static QD_TEXTI (tx71, "Log closed");
static QD_TEXTI (tx72, "Log Open");
static QD_TEXTI (ft09, "Start Script");
static QD_TEXTI (ft10, "Stop Script");
static QD_TEXTI (ft11, "User Menu");
static QD_TEXTI (ft12, "Xfer Log");

OPTLIST stDoLog[] =
{
    {&tx71, 0},
    {&tx72, 1},
    NULL
};

EDITLIST FileSetups[] =
{
    {&ft01, (void *) Qbook_dat, 0, 0, 39, EDIT, 0, 0},
    {&ft04, (void *) SendFile, 0, 0, 39, EDIT, 0, 1},
    {&ft05, (void *) CapFile, 0, 0, 39, EDIT, 0, 2},
    {&ft02, (void *) XmSFile, 0, 0, 39, EDIT, 0, 3},
    {&ft03, (void *) XmRFile, 0, 0, 39, EDIT, 0, 4},
    {&ht25, (void *) LibDir, 0, 0, 39, EDIT, 0, 5},
    {&ft06, (void *) KeyFile, 0, 0, 39, EDIT, 0, 6},
    {&ht23, (void *) DefLog, 0, 0, 39, EDIT, 0, 7},
    {&ft07, (void *) stDoLog, 0, 0, 0, TOGGLE, 0, 8},
    {&ft08, (void *) ScriptLog, 0, 0, 39, EDIT, 0, 9},
    {&ft09, (void *) StartScript, 0, 0, 39, EDIT, 0, 10},
    {&ft10, (void *) ShutScript, 0, 0, 39, EDIT, 0, 11},
    {&ft11, (void *) SMenuDat, 0, 0, 39, EDIT, 0, 12},
    {&ft12, (void *) XfrFile, 0, 0, 39, EDIT, 0, 13},
    NULL
};


void FixBaud(void)
{
    short i,j;
    int extra;
    
    if(((dbflag & 1) && (specbaud == 28 || specbaud == 30)) || (dbflag & 8)) 
    {
	lbaud = BAUD57600;
    }
    else
    {
	lbaud = BAUD19200;
	stSpeed[BAUD19200+1] = stSpeed[BAUD57600+1];
	stSpeed[BAUD19200+2] = stSpeed[BAUD57600+2];
	stExSpeed[BAUD19200+1] = stExSpeed[BAUD57600+1];
	stExSpeed[BAUD19200+2] = stExSpeed[BAUD57600+2];
	stExSpeed[BAUD19200+3] = stExSpeed[BAUD57600+3];
    }
    
    if(minnie)
    {
	osnam = "Minerva";
    }
    else if (osid == 0xfe)
    {
	osnam = "SMS2";
    }
    else if(specbaud == 28)
    {
	osnam = "SMSQXL";
    }
    else if(specbaud == 30)
    {
	osnam = "SMSQPC";
    }
    else if (specbaud > 10 && specbaud < 14)
    {
	osnam = "SMSQ/E";
    }
    else if (osid != 0xff)
    {
	osnam = "SMSQ";
    }	
    else
    {
	osnam = "QDOS";
    }

#ifdef DYNASER
    {
	char sernam[] = "ser0";
	extern short maxser;

	for(i = 0; i < maxser;i++)
	{
	    char cval =  (i+1) + '0';
	    
	    *(sernam+3) = cval;
	    if(1 /*isdevice(sernam, &extra)*/ )
	    {
		stPort[i].Text = malloc(8);
		((QD_text_t *)stPort[i].Text)->len = 4;
		stPort[i].value = cval;
		strcpy((char*)((QD_text_t *)stPort[i].Text)->chrs, sernam);
	    }
	}
    }
#endif
}

