/*
 * $Log: qsetup.c,v $
 * Revision 1.2  1995/11/12 15:29:37  root
 * Baud rates for QXL etc
 *
 * Revision 1.1  1995/09/16  17:22:18  root
 * Initial login under Linux
 *
 * Revision 1.5  1995/03/27  21:58:47  jrh
 * Fix Blank menus (please...)
 *
 * Revision 1.4  1995/03/24  16:29:31  jrh
 * Menu code & XPrefs crash
 *
 * Revision 1.3  1995/03/12  23:00:08  jrh
 * scripting
 *
 * Revision 1.2  1994/12/15  21:31:12  jrh
 * Delay et al
 *
 * Revision 1.1  1994/05/30  21:43:10  jrh
 * Initial checkin at v1.33
 *
 */

static char rcsid[] ="$Id: qsetup.c,v 1.2 1995/11/12 15:29:37 root Exp $";

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <qlib.h>
#include <qptr.h>

#include "xprmisc.h"
#include "defs.h"

#define XOFFSET 190
#define LITMOFF 92
#define ninfw 3
#define CFLAG   38

Prototype EditPrefs (struct WM_wwork *, struct QD_text *, PEDITLIST, struct WM_litm *, void *);
Local CleanupItems (PEDITLIST, struct WM_litm *, int, char *);
Prototype CleanForSave ();
Local SetupItems (PEDITLIST, struct WM_info *, struct WM_litm *, char *, int, int);
Local SetupText (PEDITLIST, struct WM_litm *);

static int MXPRCMP (struct WM_wwork *, struct WM_litm *);
static int MEDIT (struct WM_wwork *, struct WM_litm *);
static int MTOGGLE (struct WM_wwork *, struct WM_litm *);
static int MXPRSUB (struct WM_wwork *, struct WM_litm *);
static int MXPRCMD (struct WM_wwork *, struct WM_litm *);

static struct WM_action medit = {JSR, wm_actli, MEDIT};
static struct WM_action mtoggle = {JSR, wm_actli, MTOGGLE};

static struct WM_action mxprsub = {JSR, wm_actli, MXPRSUB};
static struct WM_action mxprcmd = {JSR, wm_actli, MXPRCMD};
static struct WM_action mxprcmp = {JSR, wm_actli, MXPRCMP};

static int mxpro (), mxpc (), mxpp ();

static int (*efuncs[]) () = {mxpro, mxpc, mxpp};

static int nloose;
static PEDITLIST pEdit = NULL;
static void *UserP = NULL;
static struct WM_litm *GBLitm;

extern char mono;

CleanForSave (struct WM_wwork *wwk)
{
    CleanupItems (pEdit, GBLitm, -1, NULL);
    wwk->wstat->litem[CFLAG] = 0;

}
EditPrefs (struct WM_wwork *wwk, struct QD_text *Title,
	   PEDITLIST pEd, struct WM_litm *dlitm, void *Uptr)
{
    struct WM_wstat ws;
    struct WM_wwork ww;
    struct WM_info info1[2];
    struct WM_infw infw[4];
    struct WM_info *info2;
    struct WM_litm *litm;
    PEDITLIST pl, SAVEPE;
    int SAVENL;
    void *SAVEUP;
    int nlines = 0;
    int ncol = 0;
    int ninfo = 0;
    char curval[40];
    int i;
    int bodge = 0;
    int maxtit = 0;

    SAVEPE = pEdit;
    SAVENL = nloose;
    SAVEUP = UserP;

    pEdit = pEd;
    UserP = Uptr;
 /*
  * Find prefs info items & supplied loose items data
  */

    for (ninfo = 0, pl = pEd; pl->Title; pl++, ninfo++)
    {
	if (pl->xp > ncol)
	{
	    ncol = pl->xp;
	}
	if (pl->yp > nlines)
	{
	    nlines = pl->yp;
	}
	if (((struct QD_text *) pl->Title)->len > maxtit)
	{
	    maxtit = ((struct QD_text *) pl->Title)->len;
	}
    }
    nlines++;
    ncol++;
    maxtit = maxtit * 6 + 12;
 /*
  * Find default loose items
  */
    if (UserP)
    {
	bodge = 1;
    }

    ncol += bodge;

    for (litm = dlitm, nloose = 0; litm->xsize != -1; litm++, nloose++)
	;			/* NULL LOOP */

    litm = (struct WM_litm *) xmalloc (
			 (nloose + ninfo + 1) * (sizeof (struct WM_litm)));
    memcpy (litm, dlitm, nloose * sizeof (struct WM_litm));
    info2 = (struct WM_info *) xmalloc ((sizeof (struct WM_info)) * (ninfo + 1));

    memset (&ww, 0, sizeof (ww));
    memset (&ws, 0, sizeof (ws));
    memset (infw, 0, sizeof (infw));
    memset (info1, 0, sizeof (info1));

    info1[0].xsize = (Title->len * 6);
    info1[0].ysize = 10;
    info1[0].xorg = 2;
    info1[0].yorg = 1;
    info1[0].type = 0;
    info1[0].pobj = (char *) Title;
    info1[0].attr.t.ink = 0;
    info1[1].xsize = info1[1].ysize = -1;

    infw[0].xsize = 4 + ncol * 190;
    infw[0].ysize = 14;
    infw[0].papr = (mono) ? 121 : 84;

    infw[1].xsize = info1[0].xsize + 6;
    infw[1].ysize = 12;
    infw[1].xorg = 10;
    infw[1].yorg = 2;
    infw[1].papr = 7;
    infw[1].pobl = info1;

    infw[2].xsize = infw[0].xsize - 4;
    infw[2].ysize = nlines * 11 + 1;
    infw[2].xorg = 2;
    infw[2].yorg = 15;
    infw[2].borw = 1;
    infw[2].borc = (mono) ? 7 : 4;
    infw[2].pobl = info2;
    infw[3].xsize = infw[3].ysize = -1;

    ww.wstat = &ws;
    ww.xsize = infw[0].xsize;
    ww.ysize = 16 + nlines * 11;
    ww.xorg = (bodge) ? maxtit + 16 : LITMOFF + 4;
    ww.yorg = 24;
    ww.flag = 2 + NO_WCLEAR;
    ww.borw = 1;
    ww.curw = 1;

    if(mono)
    {
        ww.borc = 1;
        ww.curc = 7;
        ww.uback = 4;
        ww.aink = 7;
        ww.sback = 7;
        ww.sink = 0;
    }
    else
    {
        ww.borc = 4;
        ww.curc = 2;
        ww.uback = 2;
        ww.aink = 7;
        ww.sback = 2;
        ww.sink = 7;
    } 
    ww.ninfo = 3;
    ww.ninob = ninfo + 1;
    ww.pinfo = infw;
    ww.nlitm = nloose + ninfo;
    ww.plitm = litm;

    ws.wwork = &ww;
    ws.citem = -1;
    ws.ciact = NULL;
    ws.wmode = FORM_QL4;

    SetupItems (pEd, info2, (litm + nloose), curval, bodge, maxtit);

    litm[nloose + ninfo].xsize = litm[nloose + ninfo].ysize = -1;
    info2[ninfo].xsize = info2[ninfo].ysize = -1;

    memset ((ws.litem + nloose), WSI_MKAV, ninfo);
    ws.litem[CFLAG] = 0;

    wm_pulld (&ww, 120 /* wwk->xorg + 60 */ , wwk->yorg + 40);
    wm_wdraw (&ww);

    while (!(wm_rptr (&ww)))
    {
	if (ws.evnt & PT_WSIZE)
	{
	    CleanupItems (pEd, (litm + nloose), 0, NULL);
	    SetupItems (pEd, info2, (litm + nloose), curval, bodge, maxtit);
	    memset ((ws.litem + nloose), WSI_MKAV, ninfo);
	    wm_ldraw (&ww, -1);
	}
	if (ws.evnt & PT_CAN)
	{
	    break;
	}
    }
    CleanupItems (pEd, (litm + nloose), ws.litem[CFLAG], curval);
    wm_cluns (&ww);
    xfree (info2);
    xfree (litm);
    pEdit = SAVEPE;
    nloose = SAVENL;
    UserP = SAVEUP;

    return ws.litem[CFLAG];
}

static CleanupItems (PEDITLIST pList, struct WM_litm *pLitm, int flag, char *curval)
{
    int i;
    PEDITLIST pl;

    pl = pList;

    for (i = 0; pl->Title; i++, pl++, pLitm++)
    {
	if (pl->type == EDIT || pl->type == XEDIT)
	{
	    if (pLitm->pobj)
	    {
		struct QD_text *s;
                short n;
                char *p;
		s = (struct QD_text *) pLitm->pobj;
		if (flag && pl->list) 
		{
		    s->chrs[s->len] = 0;
		    p = strcpy ((char *)pl->list, (char *)s->chrs);
                    p += s->len;
                    n = pl->defval - s->len;
                    while(n--)
                    {
                        *p++ = 0;
                    }
		}
		if (flag != -1)
		{
		    xfree (s);
		}
	    }
	}
	else if(curval)
        {
	    if (flag == 0)
	    {
	        pl->Change = 0;
	        pl->current = curval[i];
	    }
	    else if(pl->Change && pl->current == curval[i])
	    {
                pl->Change = 0;
	    }
	}
    }
}

static SetupText (PEDITLIST pl, struct WM_litm *pLitm)
{
    struct QD_text *s;

    s = (struct QD_text *) xmalloc (8 + pl->defval);
    strcpy ((char *)s->chrs, (char *)pl->list);
    s->len = strlen ((char *) s->chrs);
    pLitm->pobj = (char *) s;
    pLitm->xsize = (pl->defval + 1) * 6;
}
static mxpro (PEDITLIST pList, struct WM_litm *pLitm)
{
    struct QD_text *s;

    pLitm->pact = &mxprsub;
    SetupText (pList, pLitm);
}
static mxpc (PEDITLIST pList, struct WM_litm *pLitm)
{
    pLitm->pact = &mxprcmd;
    pLitm->pobj = pList->list;
    pLitm->xsize = (((struct QD_text *) pLitm->pobj)->len + 1) * 6;
}
static mxpp (PEDITLIST pList, struct WM_litm *pLitm)
{
    struct QD_text *s;

    pLitm->pact = &mxprcmp;
    SetupText (pList, pLitm);
}

static SetupItems (PEDITLIST pList, struct WM_info *pInfo,
		 struct WM_litm *pLitm, char *curval, int bodge, int maxtit)
{
    int i;
    PEDITLIST pl;

    GBLitm = pLitm;

    for (i = 0, pl = pList; pl->Title; pl++, i++)
    {
	pInfo->xsize = (bodge) ? maxtit : 80;
	pInfo->ysize = 10;
	pInfo->pobj = pl->Title;
	pInfo->xorg = pl->xp * XOFFSET + 2;
	pInfo->yorg = pl->yp * 11 + 1;
	pInfo->type = TYP_TEXT;
	pInfo->attr.t.ink = (mono) ? 7 : 4;
	pInfo->attr.t.cwid = pInfo->attr.t.chgt = 0;

	pLitm->ysize = 10;
	if (bodge)
	{
	    pLitm->xorg = (maxtit + 12) + pInfo->xorg;
	}
	else
	{
	    pLitm->xorg = LITMOFF + pInfo->xorg;
	}
	pLitm->yorg = pInfo->yorg + 15;

	if (pl->type == EDIT)
	{
	    SetupText (pl, pLitm);
	    pLitm->pact = &medit;
	}
	else if (pl->type == TOGGLE)
	{
	    POPTLIST p1, p2;

	    p1 = (POPTLIST) pl->list;
	    p2 = (p1 + pl->current);
	    if (curval)
	    {
		curval[i] = pl->current;
	    }
	    pLitm->pact = &mtoggle;
	    pLitm->pobj = p2->Text;
	    pLitm->xsize = 80;
	}
	else
	{
	    int n;
	    n = pl->type;
            if(n < 0 || n > 2)
            {
                exit(-1);
            }
	    (*efuncs[n]) (pl, pLitm);
	}
	pLitm->item = i + nloose;
	pLitm->xjst = 1;
	pLitm->yjst = 0;
	pLitm->skey = 0;
	pLitm->type = TYP_TEXT;
	pLitm++;
	pInfo++;
    }
    return i;
}

static int MEDIT (struct WM_wwork *wwk, struct WM_litm *li)
{
    PEDITLIST pe;
    char *p;
    short n;
    p = mystrdup((char *)((struct QD_text *)li->pobj)->chrs);
    wm_swlit (wwk, li->item, WSI_SLCT);
    wm_ename (wwk->chid, (struct QD_text *) li->pobj);
    pe = (pEdit + li->item - nloose);
    pe->Change = (strcmp(p, (char *)((struct QD_text *)li->pobj)->chrs) != 0);
    xfree(p);
    wwk->wstat->litem[CFLAG] = 1;
    return lit_reset (wwk, li->item);
}
static int MTOGGLE (struct WM_wwork *wwk, struct WM_litm *li)
{
    PEDITLIST pe;
    POPTLIST p1, p2;

    pe = (pEdit + li->item - nloose);
    p1 = (POPTLIST) pe->list;
    p2 = (p1 + pe->defval);

    if(wwk->wstat->kprs == 2)
    {
        pe->current++;
        p2 = (p1 + pe->current);
        if (p2->Text == NULL)
        {
	    p2 = p1;
	    pe->current = 0;
        }
    }
    else
    {
	if (pe->current ==  0)
	{
	    short j;
	    for (p2 = p1, j = 0; p2->Text ;  p2++, j++)
                 ;	/* Null Loop */
            p2--;
	    pe->current = --j;
	}
	else
	{
	    pe->current--;
            p2 = (p1 + pe->current);
	}
    }
    li->pobj = p2->Text;
    pe->Change = 1;
    wwk->wstat->litem[CFLAG] = 1;
    return lit_reset (wwk, li->item);
}

static int MXPRSUB (struct WM_wwork *wwk, struct WM_litm *li)
{
    char *q;

    q = (char *) XPRMenu (wwk);

    if (q)
    {
	PEDITLIST pe;

	((struct QD_text *) li->pobj)->len = strlen (q);
	strcpy ((char *)((struct QD_text *) li->pobj)->chrs, q);

	pe = (pEdit + li->item - nloose);
	pe->Change = 1;
    }
    wwk->wstat->litem[CFLAG] = 1;
    return lit_reset (wwk, li->item);
}

static int MXPRCMD (struct WM_wwork *wwk, struct WM_litm *li)
{
    PEDITLIST pe;
    int act;

    pe = (pEdit + li->item - nloose);
    act = pe->current;
    *(int *) UserP = 1 << act;
    wwk->wstat->litem[CFLAG] = 0;
    return PT__CAN;
}

static int MXPRCMP (struct WM_wwork *wwk, struct WM_litm *li)
{
    PEDITLIST pe;
    int act;

    MEDIT (wwk, li);
    pe = (pEdit + li->item - nloose);
    act = pe->current;
    *(int *) UserP = 1 << act;
    wwk->wstat->litem[CFLAG] = 0;
    return PT__CAN;
}
