/*
 * $Log: qvt100.c,v $
 * Revision 1.9  1998/06/12 20:03:01  jrh
 * Fixed -i bug
 *
 * Revision 1.8  1997/08/23 21:11:08  jrh
 * pre config removal
 *
 * Revision 1.7  1997/04/13 16:54:18  jrh
 * cursor and console changes
 *
 * Revision 1.6  1996/12/23 22:33:03  jrh
 * Checkin for 1.62
 *
 * Revision 1.5  1996/07/09  09:26:14  jrh
 * pre file sel (1.599)
 *
 * Revision 1.4  1995/12/30  18:28:09  root
 * For v1.57 (QXL baud, SH status, CSM crash)
 *
 * Revision 1.3  1995/11/26  14:29:04  root
 * System specific changes
 *
 * Revision 1.2  1995/11/12  15:29:37  root
 * Baud rates for QXL etc
 *
 * Revision 1.1  1995/09/16  17:22:18  root
 * Initial login under Linux
 *
 * Revision 1.16  1995/03/31  12:21:52  jrh
 * Fix mallocs to use xmalloc
 *
 * Revision 1.15  1995/03/28  18:30:06  jrh
 * Correct return of DIAL results
 *
 * Revision 1.14  1995/03/27  22:45:49  jrh
 * Add separate last dial message
 *
 * Revision 1.13  1995/03/24  16:29:31  jrh
 * Fix Wait and Dial script bugs
 *
 * Revision 1.12  1995/03/18  12:34:53  jrh
 * preparation for Viewdata
 *
 * Revision 1.11  1995/03/12  23:00:08  jrh
 * scripting
 *
 * Revision 1.10  1995/02/12  18:06:14  jrh
 * Scripting beta
 *
 * Revision 1.9  1994/12/22  17:55:07  jrh
 * Sort out local & graphics at EOL
 *
 * Revision 1.8  1994/12/15  21:31:12  jrh
 * 80 col chnages
 *
 * Revision 1.7  1994/08/23  16:48:43  jrh
 * Fix scrollong area
 *
 * Revision 1.6  1994/07/09  15:34:29  jrh
 * Changes for better vt100
 *
 * Revision 1.5  1994/06/06  18:53:18  jrh
 * Fix the ESC sp F feature as well
 *
 * Revision 1.4  1994/06/06  18:14:07  jrh
 * Fix VT1xx positioning / scrolling (for Dave Woodman).
 *
 * Revision 1.3  1994/06/05  19:10:16  jrh
 * Added VT100/Vt102 options
 *
 * Revision 1.2  1994/05/31  22:19:55  jrh
 * Additional connect options
 *
 * Revision 1.1  1994/05/30  21:43:28  jrh
 * Initial checkin at v1.33
 *
 */

static char rcsid[] = "$Id: qvt100.c,v 1.9 1998/06/12 20:03:01 jrh Exp $";

#include <stdio.h>
#include <ctype.h>
#include <qptr.h>
#include <time.h>
#include "defs.h"

Prototype VT100Init (int);
Prototype GoOnLine (void);
Prototype GoOffLine (void);
Prototype ProcessSerial (UCHAR);
Prototype VT100Esc (char);
Local SaveCursor (void);
Local LoadCursor (void);
Prototype EscVT100 (void);
Local VTSquare (char);
Local ClearToCursor (void);
Local VTHash (char);
Prototype NewLine (void);
Prototype WriteChar (UCHAR);
Prototype NextTabStop (void);
Local AddTabList (void);
Local RemTabList (void);
Prototype ScrollTop (void);
Prototype ScrollScreen (int);
Prototype void Colour (int, int, int);
Prototype VTDisplay (unsigned char ch);

#define YINC 10
#define XINC 6

LOCAL char nTab;
LOCAL UCHAR SYtop, SYbot;
LOCAL char TabBuf[132];
LOCAL UCHAR RelOrg;
LOCAL char sfCol, sbCol, sXpos, sYpos;
LOCAL char bScroll;
LOCAL char RCFlag;
LOCAL char sWrap;
LOCAL char sOrigin;
LOCAL char sSet[2];
LOCAL char svtMode;
LOCAL char *pState = NULL;
LOCAL char *pStart = NULL;
LOCAL char abold, sbold;
static char revon;

LOCAL char NrmFCol[] =
{GREEN, BLACK};
LOCAL char BoldCol[] =
{WHITE, BLACK};
LOCAL char FlashC[] =
{RED, BLACK};
LOCAL char ColorTab[] =
{GREEN, GREEN, RED, RED, BLACK, BLACK, WHITE, WHITE};
LOCAL unsigned char ANSITab[2][8] =
{
    {0, 2, 4, 242, 246, 226, 20, 7},
    {63, 80, 44, 50, 126, 26, 60, 22}};
LOCAL unsigned char ANSIBold[8] =
{WHITE, RED, GREEN, WHITE, WHITE, RED, GREEN, WHITE};

static short ConDef[4], ReDef[4];
extern char mono;
extern char nbs;
extern short srv_in_use;
extern int PollServer (void);

short backchat = 0;

#ifdef VDATA
extern ProcessVD (unsigned char);
#endif

VT100Init (int flg)
{
    int i;

    abold = sbold = 0;
    nTab = 9;
    SYtop = 0;
    SYbot = scrY - 1;

    for (i = 0; i < nTab; i++)
    {
	TabBuf[i] = 8 * (i + 1);
    }
    RelOrg = sOrigin = FALSE;
    vtMode = svtMode = 0;
    cSet[0] = sSet[0] = C_TEXT;
    cSet[1] = sSet[1] = C_GRAF;
    sXpos = 0;
    sYpos = 0;
    bVTKmode = NORM;
    bScroll = 0;
    RCFlag = 0;
    bInsert = 0;
    if (bEmulation & ANSI_M)
    {
	Colour (pChId, (int) (sbCol = bCol = BLACK), (int) (sfCol = fCol = WHITE));
	NrmFCol[0] = WHITE;
	BoldCol[0] = GREEN;
    }
    else
    {
#ifdef VDATA
	if (bEmulation == VIEWD)
	{
	    sd_setsz (pChId, -1, 2, 0);
	}
	else
	{
	    sd_setsz (pChId, -1, 0, 0);
	}
	NrmFCol[0] = WHITE;
#else
	NrmFCol[0] = (mono) ? WHITE : GREEN;
#endif
	Colour (pChId, (int) (sbCol = bCol = BLACK), (int) (sfCol = fCol = NrmFCol[0]));
	BoldCol[0] = WHITE;
    }
    sd_setpa (pChId, -1, (int) bCol);

    if (flg)
    {
	sd_pos (pChId, -1, 0, 0);
	sd_clear (pChId, -1);
	csr = 1;
	PosText ();
	if (bEmulation & DECVT)
	{
	    if (bWrap & 1)
	    {
		bWrap = sWrap = 0;
	    }
	}
    }
    revon = 0;
}

static char dline[81];
static char check[64];
static char lline[257];
static short llen = 0;

void InitDialLine (void)
{
    strcpy (dline, "\007Dial failed");
    llen = 0;
}
short LastLine (char c)
{
    static char *ptr = lline;
    static char lc = 0;
    static short new = 1;

    if (c == '\n')
    {
	new = 1;
    }
    else if (c != '\r')
    {
	if (new || lc == '\r')
	{
	    new = 0;
	    ptr = lline;
	    llen = 0;
	}
	if (llen < (sizeof (lline) - 1))
	{
	    *ptr++ = c;
	    *ptr = 0;
	}
	llen++;
    }
    lc = c;
    return llen;
}

char *IWait = NULL;
static char *iwptr;

char *ReturnLastLine (void)
{
    Report(("Last=<%s>\n", IWait));    
    return lline;
}

char *ReturnDialLine (void)
{
    return dline;
}

int AddStr (char p, char **ptr)
{
    *(*ptr)++ = p;
}

char *InitWait (char *q)
{
    if (IWait)
    {
        Report(("Init Wait NULL\n"));
	xfree (IWait);
	IWait = NULL;
    }
    if (q)
    {
	IWait = iwptr = xmalloc (strlen (q) + 2);
	ParseString (q, AddStr, 0, &iwptr);
	*iwptr = 0;
	iwptr = IWait;
        Report(("Init=<%s>\n", IWait));
    }
    return IWait;
}

int CheckDial (ch)
{
    if (ch != *pState++)
    {
	pState = pStart;
	return 0;
    }
    else if (*pState == 0)
    {
	return 1;
    }
}

int CheckWait (ch)
{
    if (IWait && iwptr)
    {
	if (ch == *iwptr++)
	{
	    if (*iwptr == 0)
	    {
                Report(("Match=<%s>\n", IWait));
		InitWait (NULL);
	    }
	    if (srv_in_use == 1)
	    {
		PollServer ();
	    }
	}
	else
	{
	    iwptr = IWait;
	}
    }
}

void SetString (char *str)
{
    char *Ptr;

    pState = pStart = Ptr = check;
    ParseString (str, AddStr, 0, &Ptr);
    *Ptr = 0;
}
GoOnLine ()
{
    qC->dState = Q_DONE;
    qC->qState = Q_ONLINE;
    qC->qClock = time (NULL);

    SetString (MdmCtrl[7]);
    if (bBeep)
    {
	SOUND_OFF;
    }
}

GoOffLine (void)
{
    SetString (MdmCtrl[6]);
    qC->dState = 0;
    qC->qState = Q_WAIT;
    SrvStats ("Idle");
}

static char *dmsgs[] =
{"BUSY", "NO ", "ERROR", NULL};

static short CheckResp (void)
{
    char *p, *q;
    short rv = 0;

    for (q = lline; *q; q++)
    {
	if (CheckDial (*q) == 1)
	{
            Report(("CheckDial %s OK\n", lline));
	    return 1;
	}
    }
    {
	char **qq;

	for (qq = dmsgs; *qq; qq++)
	{
            Report(("Cmp <%s> <%s>\n", lline, *qq));

	    if (strnicmp (lline, *qq, strlen (*qq)) == 0)
	    {
		rv = -1;
		break;
	    }
	}
    }
    return rv;
}
ProcessSerial (UCHAR ch)
{
    LastLine (ch);

    if (IWait)
    {
	CheckWait (ch);
    }

    if (backchat)
    {
	if (ch == BS || ch == DEL)
	{
	    (*pS->SendStr) ("\010 \010");
	}
	else
	{
	    (*pS->SendChr) (ch);
	}
    }

    if (qC->qState == Q_DIAL)
    {
	if (ch == '\n' && llen)
	{
	    short dresp;

	    if (strnicmp (lline, "AT", 2) && strnicmp (lline, "OK", 2))
		strncpy (dline, lline, sizeof (dline) - 1);
	    dresp = CheckResp ();

	    if (dresp == 1)
	    {
		GoOnLine ();

		if (qC->dTry == 0 || qC->dWait == 0)
		{
		    pick (pChId, -1, QTpid, K_WAKE);
		}
	    }
	    if (dresp == -1)
	    {
		SrvStats ("Idle");
		if (qC->dTry > 0 && qC->dWait > 0)
		{
		    qC->dState = Q_WAIT;
		}
		else
		{
		    qC->dState = 0;
		    qC->qState = Q_WAIT;
		    pick (pChId, -1, QTpid, K_WAKE);
		}
	    }
	}
    }
    else if (qC->qState == Q_ONLINE)
    {
	if (CheckDial (ch) == 1)
	{
	    GoOffLine ();
	}
    }

    AddCapBuff (&Cap, ch);

    if (ScreenMode == 0 && QAwake)
    {
	VTDisplay (ch);

	if ((pS->Count == 0 || bLocal) && csr)
	{
	    PosText ();
	}
    }

}
VTDisplay (unsigned char ch)
{
#ifdef VDATA
    if (bEmulation == VIEWD)
    {
	ProcessVD (ch);
    }
    else
#endif
    {
	switch (sState)
	{
	    case SNORM:
		ProcessNorm (ch);
		break;
	    case SESC:
		switch (bEmulation)
		{
		    case VT52:
			VT52Esc (ch);
			break;
		    case VT100:
		    case VT102:
		    case ANSI1:
		    case ANSI2:
		    case ANSI3:
		    case ANSI4:
			VT100Esc (ch);
			break;
		}
		break;
	    default:
		if (sState != SESCEX)
		{
		    AddEscBuffer (ch);
		}
		break;
	}
	if (sState == SESCEX)
	{
	    ReadCsr (pChId, &Xpos, &Ypos);
	    DoEscSeq ();
	}
    }
}
VT100Esc (char ch)
{
    *pEscBuf++ = ch;

    switch (ch)
    {
	case SS:
	case CAN:
	    CanSub (ch);
	    break;
	case '[':
	case ' ':
	    sState = SESCPM;
	    break;

	case '#':
	    sState = SESCNO;
	    break;

	case '(':
	case ')':
	case '*':
	case '+':
	    sState = SESCGx;
	    break;

	default:
	    sState = SESCEX;
	    break;
    }
}
static SaveCursor ()
{
    sbCol = bCol;
    sfCol = fCol;
    sXpos = Xpos;
    sYpos = Ypos;
    sSet[0] = cSet[0];
    sSet[1] = cSet[1];
    sWrap = bWrap;
    svtMode = vtMode;
    sOrigin = RelOrg;
    sbold = abold;
}
static LoadCursor ()
{
    Colour (pChId, (int) (bCol = sbCol), (int) (fCol = sfCol));
    sd_pos (pChId, -1, (int) sXpos, (int) sYpos);
    cSet[0] = sSet[0];
    cSet[1] = sSet[1];
    bWrap = sWrap;
    vtMode = svtMode;
    RelOrg = sOrigin;
    abold = sbold;
}

EscVT100 ()
{
    char ch0;
    char ch1;
    int s;

    ch0 = EscBuf[0];
    ch1 = *(--pEscBuf);

    switch (ch0)
    {
	case '[':
	    VTSquare (ch1);
	    break;
	case '#':
	    VTHash (ch1);
	    break;
	case '(':
	case ')':
	case '*':
	case '+':
	    if (ch0 == '(')
	    {
		s = 0;
	    }
	    else
	    {
		s = 1;
	    }
	    if (ch1 == '0')
	    {
		cSet[s] = C_GRAF;
	    }
	    else
	    {
		cSet[s] = C_TEXT;
	    }
	    break;
	default:
	    switch (ch0)
	    {
		case '7':
		    SaveCursor ();
		    break;
		case '8':
		    LoadCursor ();
		    break;
		case 'H':
		    AddTabList ();
		    break;

		    /* Ignore = > to set keypad modes */

		case 'c':
		    VT100Init (1);
		    break;
		case 'M':
		    ScrollTop ();
		    break;
		case 'D':
		    NewLine ();
		    sd_tab (pChId, -1, Xpos);
		    break;
		case 'E':
		    NewLine ();
		    break;
		case 'Z':
		    if (bLocal != 1)
		    {
			(*pS->SendStr) ((bEmulation == VT100) ? "\033[?1;2c" : "\033[?6c");
		    }
		    break;

	    }
    }
}

static void DoRevVid (char val)
{
    if ((revon && val == 27) || (revon == 0 && val == 7))
    {
	bCol ^= fCol;
	fCol ^= bCol;
	bCol ^= fCol;
	Colour (pChId, (int) bCol, (int) fCol);
	revon ^= 1;
    }
}

LOCAL VTSquare (char ch1)
{
    char *ptr;
    short pBuf[16];
    char Rbuf[16], *Rptr;
    int dval, nChar, i, j, ic, mc, nCol;
    char c;
    char qMark;
    USHORT wFreq;

    ptr = EscBuf + 1;
    if (*ptr == '?')
    {
	ptr++;
	qMark = 1;
    }
    else
    {
	qMark = 0;
    }

    dval = nChar = 0;
    while (*ptr)
    {
	c = *ptr++;
	if (c >= '0' && c <= '9')
	{
	    dval = dval * 10 + (c - '0');
	}
	else
	{
	    pBuf[nChar++] = dval;
	    dval = 0;
	}
    }
    pBuf[nChar] = 0;

    if (qMark == 0)
    {
	switch (ch1)
	{
	    case 'H':
	    case 'f':
		if (pBuf[0])
		{
		    pBuf[0] -= 1;
		}
		
		if (pBuf[1])
		{
		    pBuf[1] -= 1;
		}
		if (RelOrg)
		{
		    pBuf[0] = SYtop + Ypos;
		}
		
		if (pBuf[1] > (scrX-1))
		    pBuf[1] = (scrX-1);
		if (pBuf[1] < 0)
		    pBuf[1] = 0;
		if (pBuf[0] > scrY - 1)
		    pBuf[0] = scrY - 1;
		if (pBuf[0] < 0)
		    pBuf[0] = 0;
		
		sd_pos (pChId, -1, (int) pBuf[1], (int) pBuf[0]);
		break;
		
	    case 'A':
		i = (pBuf[0]) ? pBuf[0] : 1;
		for (j = 0; (j < i && Ypos > SYtop); j++)
		{
		    sd_prow (pChId, -1);
		    Ypos--;
		}
		break;
	    case 'B':
		i = (pBuf[0]) ? pBuf[0] : 1;
		for (j = 0; (j < i && Ypos < SYbot); j++)
		{
		    sd_nrow (pChId, -1);
		    Ypos++;
		}
		break;
	    case 'C':
		i = (pBuf[0]) ? pBuf[0] : 1;
		{
		    for (j = 0; j < i; j++)
		    {
			sd_ncol (pChId, -1);
		    }
		}
		break;
	    case 'D':
		i = (pBuf[0]) ? pBuf[0] : 1;
		{
		    for (j = 0; j < i; j++)
		    {
			sd_pcol (pChId, -1);
		    }
		}
		break;
		
	    case 'K':
		switch (pBuf[0])
		{
		    case 0:
			sd_clrrt (pChId, -1);
			break;
		    case 1:
			ClearToCursor ();
			break;
		    case 2:
		    default:
			sd_clrln (pChId, -1);
			break;
		}
		break;
		
	    case 'J':
		switch (pBuf[0])
		{
		    case 0:
			sd_clrrt (pChId, -1);
			sd_clrbt (pChId, -1);
			break;
		    case 1:
			sd_clrtp (pChId, -1);
			ClearToCursor ();
			break;
		    case 2:
		    default:
			sd_clear (pChId, -1);
			break;
		}
		break;
		
	    case 'L':
	    case 'M':
		WinPos (pChId, ConDef);
		ReDef[1] = (YINC) * (SYbot - Ypos + 1);
		ReDef[3] = ConDef[3] + Ypos * (YINC);
		j = (YINC) * ((pBuf[0]) ? pBuf[0] : 1);
		if (ch1 == 'M')
		{
		    j = -j;
		}
		ScrollScreen (j);
		break;
		
	    case 'P':
		j = -XINC * ((pBuf[0]) ? pBuf[0] : 1);
		Pan (pChId, j);
		break;
		
	    case 'm':
		j = RCFlag ^ 1;
		for (i = 0; i < nChar; i++)
		{
		    if (bEmulation & DECVT)
		    {
			switch (pBuf[i])
			{
			    case 0:
				sd_setul (pChId, -1, 0);
				DoRevVid (27);
			    case 22:
			    case 25:
				Colour (pChId, (int) (bCol = NrmFCol[j]),
					(int) (fCol = NrmFCol[RCFlag]));
			    case 24:
				sd_setul (pChId, -1, 0);
				break;
			    case 1:
				Colour (pChId, (int) (bCol = BoldCol[j]),
					(int) (fCol = BoldCol[RCFlag]));
				break;
			    case 4:
				sd_setul (pChId, -1, 1);
				break;
			    case 5:
				Colour (pChId, (int) (bCol = FlashC[j]),
					(int) (fCol = FlashC[RCFlag]));
				break;
			    case 7:
			    case 27:
				DoRevVid (pBuf[i]);
				break;
			}
		    }
		    else
		    {
			switch (pBuf[i])
			{
			    case 1:
				if (bEmulation & ANSI_BOLD)
				{
				    abold = 1;
				}
				break;
			    case 0:
				abold = 0;
				DoRevVid (27);
				Colour (pChId, (int) (bCol = NrmFCol[1]),
					(int) (fCol = NrmFCol[0]));
			    case 24:
				sd_setul (pChId, -1, 0);
				break;
			    case 4:
				sd_setul (pChId, -1, 1);
				break;
			    case 7:
			    case 27:
				DoRevVid (pBuf[i]);
				break;
			    case 39:
				Colour (pChId, (int) bCol,
					(int) (fCol = NrmFCol[0]));
				break;
			    case 49:
				Colour (pChId, (int) (bCol = NrmFCol[1]),
					(int) fCol);
				break;
			    default:
				ic = pBuf[i] % 10;
				mc = pBuf[i] / 10;
				if (ic >= 0 && ic < 8)
				{
				    if (bEmulation & ANSI_8COL)
				    {
					nCol = ANSITab[mc == 3 ? abold : 0][ic];
				    }
				    else
				    {
					nCol = (ic % 4) * 2;
				    }
				    if (mc == 3)
				    {
					if (abold && (bEmulation == ANSI4))
					{
					    if (bCol != ANSIBold[ic])
					    {
						nCol = ANSIBold[ic];
					}
					}
					Colour (pChId, (int) bCol,
						(int) (fCol = nCol));
				    }
				    if (mc == 4)
				    {
					Colour (pChId, (int) (bCol = nCol),
						(int) fCol);
				    }
				}
				break;
			}
		    }
		}
		break;

	    case 'n':
		switch (pBuf[0])
		{
		    case 6:
			Rptr = Rbuf;
			sprintf (Rbuf, "\033[%d;%dR", Ypos + 1, Xpos + 1);
			break;
		    case 5:
			Rptr = "\033[0n";
			break;
		    case 15:
			Rptr = "\033[?13n";
			break;
		}
		if (bLocal != 1)
		{
		    (*pS->SendStr) (Rptr);
		}
		break;
	    case 'c':
		if (pBuf[0] == 0 && bLocal != 1)
		{
		    (*pS->SendStr) ("\033[?6c");
		}
		break;
	    case 'r':
		if (pBuf[0])
		{
		    pBuf[0] -= 1;
		}
		
		SYtop = pBuf[0];
		SYbot = (pBuf[1]) ? pBuf[1] - 1 : scrY - 1;
		
		if (SYtop > scrY - 1)
		    SYtop = 0;
		if (SYbot > scrY - 1)
		    SYbot = scrY - 1;
		
		if (SYtop == 0 && SYbot == scrY - 1)
		{
		    bScroll = 0;
		}
		else
		{
		    bScroll = 1;
		}
		ReDef[1] = (YINC) * (SYbot - SYtop + 1);
		WinPos (pChId, ConDef);
		ReDef[3] = ConDef[3] + SYtop * (YINC);
		sd_pos (pChId, -1, 0, SYtop);
		break;
		
	    case 'l':
	    case 'h':
		switch (pBuf[0])
		{
		    case 20:
			if (ch1 == 'h')
			{
			    Setups[SET_TX_EOL].current = bTXEOL = EOLCRLF;
			    Setups[SET_RX_EOL].current = bRXEOL = EOLLF;
			}
			else
			{
			    Setups[SET_TX_EOL].current = bTXEOL = EOLCR;
			    Setups[SET_RX_EOL].current = bRXEOL = EOLCRLF;
			}
			break;
		    case 4:
			bInsert = (ch1 == 'h');
			break;
		}
		break;
	    case 'g':
		if (pBuf[0] == 0)
		{
		    RemTabList ();
		}
		else if (pBuf[0] == 3)
		{
		    nTab = 0;
		}
		break;
	    case 's':
		/* sXpos = Xpos;   sYpos = Ypos; */
		SaveCursor ();
		break;
	    case 'u':
		/*
	     * sd_pos (pChId, -1, (int) (Xpos = sXpos), (int) (Ypos =
	     * sYpos));
	     */
		LoadCursor ();
		break;
	}
    }
    else
    {
	extern void NewSize(char);
	switch (pBuf[0])
	{
	    case 1:
		bVTKmode = (ch1 == 'l');
		break;
		
	    case 2:
		if (ch1 == 'l')
		{
		    VT100Init (1);
		    bEmulation = VT52;
		}
		break;
	    case 3:
	    {
		extern char mvwin[];
		mvwin[0] = 1;
		mvwin[1] = ch1;
		pick (pChId, -1, QTpid, K_WAKE);
	    }
	    break;
	    case 4:
		jScroll = (ch1 == 'h') ? 0 : 10;
		sprintf (TScroll, "%d", jScroll);
		break;
	    case 5:
		j = (ch1 == 'h') ? 1 : 0;
		if (j != RCFlag)
		{
		    RCFlag = j;
		    if (pS->bFlow && (bLocal != 1))
		    {
			(*pS->SendChr) (XOFF);
		    }
		    sd_recol (pChId, -1, ColorTab);
		    c = bCol;
		    bCol = fCol;
		    fCol = c;
		    Colour (pChId, (int) bCol, (int) fCol);
		    sd_setpa (pChId, -1, (int) bCol);
		    if (pS->bFlow && (bLocal != 1))
		    {
			(*pS->SendChr) (XON);
			    }
		}
		break;
	    case 6:
		RelOrg = (ch1 == 'h');
		break;
		
	    case 7:
		bWrap = (ch1 == 'h');
		break;
		
	    case 8:
		wFreq = (ch1 == 'h') ? wRep : 32767;
		(short) *((short *) ((char *) (_sys_var + 0x8C))) = wFreq;
		break;
	    case 25:
		if (ch1 == 'h')
		{
		    csr = 1;
		    PosText ();
		}
		else
		{
		    csr = 0;
		    PosNull ();
		}
		break;
	}
    }
}

LOCAL
ClearToCursor ()
{
    int i;
    int xp = Xpos;

    sd_tab (pChId, -1, 0);
    for (i = 0; i < xp; i++)
    {
	WriteChar (' ');
    }
}

LOCAL VTHash (char ch1)
{
    int i, j;
    int ch;

    switch (ch1)
    {
	case '3':
	    sd_setsz (pChId, -1, 2, 1);
	    sCount = 3;
	    break;
	case '4':
	    sCount = 0;
	    break;
	case '5':
	    sd_setsz (pChId, -1, 0, 0);
	    break;
	case '6':
	    sd_setsz (pChId, -1, 2, 0);
	    sCount = 3;
	    break;
	case '7':
	case '8':
	    sd_pos (pChId, -1, 0, 0);
	    for (ch = 'E', i = 0; i < scrY; i++)
	    {
		for (j = 0; j < scrX; j++)
		{
		    io_sbyte (pChId, -1, ch);
		    if (ch1 == '7')
		    {
			ch++;
			if (ch > 127)
			{
			    ch = 32;
			}
		    }
		}
		sd_nl (pChId, -1);
	    }
	    break;
    }
}

NewLine ()
{
    int xp;
    int sts;
 
    if(oflag)
    {
	sd_tab(pChId, -1, 0);
	sd_clrrt(pChId, -1);
    }
    else
    {
	if (sCount & 2)
	{
	    sd_setsz (pChId, -1, 0, 0);
	}
	sCount = 1;
	if (!bScroll)
	{
	    sts = sd_nl (pChId, -1);
	    if (sts < 0)
	    {
		if (jScroll)
		{
		    sd_scrol (pChId, -1, -jScroll * (YINC));
		    sd_pos (pChId, -1, 0, scrY - jScroll);
		}
		else
		{
		    io_sbyte (pChId, -1, '\n');
		    sd_donl (pChId, -1);
		}
	    }
	    else
	    {
		sd_donl (pChId, -1);
	    }
	}
	else
	{
	    ReadCsr (pChId, &Xpos, &Ypos);
	    xp = Xpos;
	    if (Ypos >= SYbot)
	    {
		ScrollScreen (-(YINC));
		sd_pos (pChId, -1, 0, (int) SYbot);
		sd_clrln (pChId, -1);
	    }
	    else
	    {
		/* Can't imagine why it's done like this */
		sd_pos (pChId, -1, 0, (int) Ypos);
		sd_pos (pChId, -1, 0, (int) Ypos + 1);
	    }
	    Xpos = xp;
	}
    }
    lastpr = LF;
}

WriteChar (UCHAR ch)
{
    int req = 1;

    if ((bEmulation & DECVT) && cSet[vtMode] == C_GRAF)
    {
	if (ch > '_' && ch < 127)
	{
	    req = 3;
	}
    }

    if (bCtrl && ch < 32)
    {
	req = 2;
    }

    if (req == 2)
    {
	CtlFont (pChId);
    }
    if (req == 3)
    {
	DECGraf (pChId);
    }

    if (bCtrl && ch < 32)
    {
	io_sbyte (pChId, -1, (char) ch);
    }
    else if (ch > 31 || ((bEmulation & ANSI_M) && ch))
    {
	req |= 4;
	if (bInsert && ch > 31 || bWrap == 0)
	{
	    if (bWrap == 0)
	    {
		ReadCsr (pChId, &Xpos, &Ypos);
		if (Xpos == (scrX-1))
		{
		    short flg;

		    req &= ~4;
		    if (csr && (Ypos == SYbot))
		    {
			flg = 1;
			sd_curs (pChId, -1);
		    }
		    else
		    {
			flg = 0;
		    }
		    io_sbyte (pChId, -1, (char) ch);
		    sd_pos (pChId, -1, (scrX-1), (int) Ypos);
		    if (flg)
		    {
			sd_cure (pChId, -1);
		    }
		    nbs++;
		}
		else
		{
		    nbs = 0;
		}
	    }
	    else
	    {
		Pan (pChId, XINC);
	    }
	}
	if (req & 4)
	{
	    io_sbyte (pChId, -1, (char) ch);
	}
    }
    if (req & 2)
    {
	QLFont (pChId);
    }
    lastpr = ch;
}

NextTabStop ()
{
    int nt;
    int i;

    ReadCsr (pChId, &Xpos, &Ypos);
    if (bEmulation & VT100_M)
    {
	nt = (scrX-1);
	for (i = 0; i < nTab; i++)
	{
	    if (TabBuf[i] > Xpos)
	    {
		nt = TabBuf[i];
		break;
	    }
	}
    }
    else
    {
	nt = (Xpos - (Xpos % 8)) + 8;
	if (nt > (scrX-1))
	{
	    nt = scrX-1;
	}
    }

    sd_pos (pChId, -1, nt, (int) Ypos);
}

LOCAL
AddTabList ()
{
    int i, k = 0;

    for (i = 0; i < nTab; i++)
    {
	if (TabBuf[i] < Xpos)
	{
	    break;
	}
    }
    nTab++;
    k = i;
    for (i = nTab; i > k;)
    {
	TabBuf[i] = TabBuf[--i];
    }
    TabBuf[k] = Xpos;
}

LOCAL
RemTabList ()
{
    int i, k;

    for (i = 0; i < nTab; i++)
    {
	if (TabBuf[i] == Xpos)
	{
	    break;
	}
    }
    if (i != nTab)
    {
	for (k = i; k < nTab;)
	{
	    TabBuf[k] = TabBuf[++k];
	}
	nTab--;
    }
}

ScrollTop ()
{
    ReadCsr (pChId, &Xpos, &Ypos);
    if (Ypos != SYtop)
    {
	sd_prow (pChId, -1);
    }
    else
    {
	ScrollScreen (YINC);
	sd_pos (pChId, -1, (int) Xpos, (int) SYtop);
	sd_clrln (pChId, -1);
    }
}

ScrollScreen (dirn)
int dirn;
{

    WinPos (pChId, ConDef);
    ReDef[0] = ConDef[0];
    ReDef[2] = ConDef[2];
    sd_wdef (pChId, -1, 0, 0, (struct QLRECT *) ReDef);
    Scroll (pChId, dirn);
    sd_wdef (pChId, -1, 0, 0, (struct QLRECT *) ConDef);
}
void Colour (int chan, int bcol, int fcol)
{
    sd_setin (chan, -1, fcol);
    sd_setst (chan, -1, bcol);
}
