#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <stdarg.h>
#include <string.h>
#include <things.h>
# include <qdos.h>

#ifndef PBDEMO
# include "defs.h"
#else
 extern char ScriptLog[];
#endif

extern int OpenAppend(char *nam, int jobid);
extern int io_open3(char *, int, int);
extern char *GetScriptLog (void);


int TryThing(char *thing, char *cmd, short timo, void **pt, int nfn,...)
{
    int sts;
    THING_HEADER_EXEC *t;
    long vers;
    THING_LINKAGE *p;
    struct JOBHEADER *jh;                   /* ha ha */

    *pt = NULL;
    sts = (int) sms_uthg(thing, -1, -1, NULL, NULL, (long *)&vers, &p);
    if(sts > 0)
    {
        t = (THING_HEADER_EXEC *) sts;
        if(t->thh.thh_type == THT_EXEC)
        {
            long sa;
            long ha;
            void *jb, *stk;
            short elen, nlen;
                
            sa = (long)t + t->thh_strt;
            ha = (long)t + t->thh_hdrs; 

            sts = mt_cjob(t->thh_hdrl, t->thh_data+4, (char *) sa, 0, &jb);
            if(sts > 0)
            {
                memcpy(jb, (void *) ha, t->thh_hdrl);
                jh = (((struct JOBHEADER *)jb) - 1);
                stk = (void *) jh->jb_regs.jb_A7;
                if(cmd && (nlen = strlen(cmd)))
                {
                    elen = (nlen+1) & ~1;
	        }
                else
                {
                    nlen = elen = 0;
	        } 

                if(nfn == -1)
                {
                    elen = elen + (3 << 2);     /* 3 channels */
                }

                if(elen)
                {
                    ((char *)stk) -= elen;
                    (void *) jh->jb_regs.jb_A7 = stk;
    	        }
                if(nfn == 0)
                {
                    *((short *) stk)++ = 0;
                }
                else if(nfn == -1)        /* kludge for QTPI  */
                {                         /* and SBASIC Thing */
		    va_list va;
                    char *fn;
                    va_start (va, nfn);
                    fn = va_arg(va, char *);
                    *((short *) stk)++ = 3;
                    *((long *) stk)++ = io_open3(fn, 0, sts);
                    *((long *) stk)++ = io_open3("nul", 0, sts);
                    *((long *) stk)++ = OpenAppend(GetScriptLog(), sts);
                    va_end(va);
		}

                *((short *)stk)++ = nlen;
                while (nlen--)
                {
                    *((char *)stk)++ = *cmd++;
                }
                sts = mt_activ(sts, 8, timo);
                sms_fthg(thing, -1, NULL, 0, NULL, NULL);
            }
            *pt = t;
        }
        else
        {
            sts = -15;
        }
    }
    else
    {
        sts = -7;
    }
    return sts;
}

#ifndef PBDEMO
char * FullName(char *name, char *myname)
{
    char *p;
    int fnd;
    
    if(isdirdev (name) == 0)
    {
        if(getcpd(myname, 32))
        {
            p = strcat(myname, name);
        }
        if(access(p, 1) != 0)
        {
            if(getcwd(myname, 32))
            {
                p = strcat(myname, name);
            }
            else
            {
                p = name;
            }
        }
    }
    else
    {
        p = name;
    }
    return p;
}

static int CheckFile(char *nam, char **snam, int *id)
{
    int xid = 0;

    if(*nam == '#')
    {
        if(*(nam + 1) == 's' || *(nam+1) == 'c')
        {
            if(snam)
            {
                *snam = (char *)-1;
            }
            *id = (*(nam + 1) == 'c') ? pChId : pS->pSerId;
        }
    }
    else
    {
        if(snam)
        {
            *snam = nam;
            *id = 0;
        }
        else
        {
            xid = OpenAppend(nam, -1);
            *id = xid;
        }
    }
    return xid;
}

int SpawnCommand(char *cmd)
{
    char *p, *s;
    int nchan = 0;
    char *chans[4];
    char *pnam = NULL;
    short done = 0;
    char lc = 0;
    char *args = NULL;
    SJOB sj;
    int stat, xid = 0;
    const void *th = NULL;
    
    memset(&sj, 0, sizeof(SJOB));

    for(s = p = cmd; !done; )
    {
        if(*p == ',' || *p == ';' || *p == 0)
        {
            done = (*p == 0);
            if(lc == 0)
            {
                pnam = s;
            }
            else if(lc == ',')
            {
                chans[nchan] = s;
                nchan++;
            }
            else if(lc == ';')
            {
                args = s;
            }
            lc = *p;
            *p = 0;
            s = ++p;            
        }
        else
        {
            p++;
        }
    }

    if(nchan == 0 &&  isdirdev (pnam) == 0)
    {
        stat = TryThing(pnam, args, -1, &th, 0);
    }

    if(th == NULL)
    {
        char exnam[64];
        sj.FileName = FullName(pnam, exnam);
        sj.ComStr = args;
        sj.Wait = 255;
        sj.Prio = 1;
        sj.JobId = -1;

        switch(nchan)
        {
            case 0:
                break;
            case 1:
                CheckFile(chans[0], &sj.OuFile, &sj.ouid);
                break;
            case 2: 
                CheckFile(chans[0], &sj.InFile, &sj.inflag);
                CheckFile(chans[1], &sj.OuFile, &sj.ouid);
                break;
            default:
                CheckFile(chans[0], &sj.InFile, &sj.inflag);
                xid = CheckFile(chans[1], NULL, &sj.serr);
                CheckFile(chans[2], &sj.OuFile, &sj.ouid);
                break;
        }
    
        stat = spawn(&sj);
        if(xid)
        {
            io_close(xid);
        }
    }
    return stat;
}

#else


int main (int ac, char **av)
{
    char *sp,*mp;
    short nc,n;
    char *basnam,*lognam;
    void *ph;

    sp = *(av + 1);		// supplied sp
    nc = *((short *) sp)++;	// channels

    if (nc)
    {
	sp += (nc << 2);	// skip channels
    }

    nc = *((short *) sp)++;
    n = nc;
    mp = malloc(nc+1);
    strncpy(mp, sp, nc);
    *(mp+nc) = '\0';

    while(n-- && *mp == ' ')
    {
        mp++;
    }

    basnam = mp;
    if(lognam = strchr(mp, ' '))
    {
        *lognam++ = '\0';
        while(*lognam == ' ')
        {
            lognam++;
        }
    }
    else
    {
        lognam = "ram1_pbdemo_log";
    }
    strcpy(ScriptLog, lognam);
    TryThing("sbasic", "This is CMD$", -1, &ph, -1, basnam);
}
int (*_Cstart) (int, char **) = main;

#endif
