/*
 * $Log: view.c,v $
 * Revision 1.4  1998/06/12 20:03:01  jrh
 * Fixed -i bug
 *
 * Revision 1.3  1997/08/23 21:13:39  jrh
 * pre config removal
 *
 * Revision 1.2  1995/11/26 14:29:04  root
 * Unchanged ?
 *
 * Revision 1.1  1995/09/16  17:22:18  root
 * Initial login under Linux
 *
 * Revision 1.9  1995/04/17  22:00:45  jrh
 * Things & fix local lockup
 *
 * Revision 1.8  1995/04/08  20:53:27  jrh
 * Add Thing functionality
 *
 * Revision 1.7  1995/03/31  12:21:52  jrh
 * Fix mallocs to use xmalloc
 *
 * Revision 1.6  1995/03/20  19:26:23  jrh
 * Fix wm_scale in ww
 *
 * Revision 1.5  1995/03/18  12:15:37  jrh
 * C68 v4.5
 *
 * Revision 1.4  1995/03/12  23:03:31  jrh
 * Make rev buf 80 cols (for Hans W)
 *
 * Revision 1.3  1994/12/15  21:31:12  jrh
 * ?
 *
 * Revision 1.2  1994/05/31  22:19:55  jrh
 * c68 v4.13c fixes
 *
 * Revision 1.1  1994/05/30  21:44:25  jrh
 * Initial checkin at v1.33
 *
 */

static char rcsid[] ="$Id: view.c,v 1.4 1998/06/12 20:03:01 jrh Exp jrh $";

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifdef SIGS
#include <signal.h>
extern void _Signals_Init();
#endif
#include <qdos.h>
#include <qptr.h>
#include <qlib.h>

#include "defs.h"

extern long re_size (struct WM_wwork *, short, short);

static DoText (struct WM_wwork *, int, int);
static ShowPct(struct WM_wwork *);

static long ACTRL (struct WM_wwork *, struct WM_appw *, struct WM_wstat *, short, short, short, short);
static struct WM_action actrl = {JSR, wm_ctlaw, ACTRL};

static long AHIT (struct WM_wwork *, struct WM_appw *, struct WM_wstat *, short, short, short);
static long AEXIT (struct WM_wwork *, struct WM_litm *);
static long ADRAW (struct WM_wwork *, struct WM_appw *);
static long MMOVE(struct WM_wwork *wwk);
static long MBARS (struct WM_wwork *, struct WM_litm *);

static struct WM_action afun = {JSR, wm_actli, lit_event};
static struct WM_action aexit = {JSR, wm_actli, AEXIT};
static struct WM_action adraw = {JSR, wm_drwaw, ADRAW};
static struct WM_action ahit = {JSR, wm_hitaw, AHIT};
static struct WM_action mmove = {JSR, wm_actli, MMOVE};
static struct WM_action mbars = {JSR, wm_actli, MBARS};

#define NINFW    2		/* number of information windows */
#define NINFO    1		/* number of information objects */
#define NLITM    5		/* number of loose items */
#define NAPPL    1		/* number of application sub-windows */

#define min_wid     220
#define min_hgt     94
#define max_hgt     254

static QD_TEXTI (END, "ESC");

extern struct WM_sprite mes_move, mes_size, mes_wake;

extern char mono;

#define XBARS 8

static void *qmalloc( int n)
{
    char *p = NULL;

    if(n)
    {
	long m;
	
	p = mt_alchp(n, &m, -1);
	if((long)p <= 0)
	{
	    exit((long)p);
	}
	memset(p, '\0', n);
    }
    return p;
}
static void qfree(void *p)
{
    mt_rechp(p);
}

typedef struct WM_menw WM_menw_t;

WM_wwork_t *NewWindow(CAPDEF_t *c)
{
    void *view;
    WM_wstat_t *ws;
    WM_wwork_t *ww;
    WM_info_t *info;
    WM_infw_t *infw;
    WM_litm_t *litm;
    WM_menw_t *aw0;
    WM_appl_t *appl;
    WM_wscale_t *wsc;
    short ysz;
    short ns,ns1;

    ns = strlen(c->name);
    view = qmalloc(4 + ns + 6);

#define INIWID (c->maxw)

    ysz = 10 *((c->maxw/16)-16); 

    *(short*)view = ns+6;
    memcpy((char *)view+2, c->name, ns);
    memcpy((char *)view+2+ns, "      ", 6);

    info = qmalloc((NINFO+1)*sizeof(WM_info_t));

    (info+0)->xsize = 6*(ns+6);
    (info+0)->ysize = 10;
    (info+0)->xorg = 6;
    (info+0)->pobj = view;
    (info+1)->xsize = (info+1)->ysize = -1;

    infw = qmalloc((NINFW+1)*sizeof(WM_infw_t));

    (infw+0)->xsize = INIWID;
    (infw+0)->ysize = 14;
    (infw+0)->borc = 7;
    (infw+0)->papr = 84;

    ns1 = (ns+6)*6+12;
    (infw+1)->xsize = ns1;
    (infw+1)->ysize = 12;
    (infw+1)->xorg = 4+(INIWID-ns1)/2;
    (infw+1)->yorg = 1;
    (infw+1)->papr = 7;
    (infw+1)->pobl = info;

    (infw+2)->xsize = (infw+2)->ysize = -1;

    litm = qmalloc(sizeof(WM_litm_t)*(NLITM + 1));

    (litm+0)->xsize = 22;
    (litm+0)->ysize = 10;
    (litm+0)->xorg = 2;
    (litm+0)->yorg = 2;
    (litm+0)->type = 2;
    (litm+0)->skey = K_MOVE;
    (litm+0)->pobj = &mes_move;
    (litm+0)->pact = &mmove;

    (litm+1)->xsize = 22;
    (litm+1)->ysize = 10;
    (litm+1)->xorg = 28;
    (litm+1)->yorg = 2;
    (litm+1)->type = 2;
    (litm+1)->skey = K_SIZE;
    (litm+1)->pobj = &mes_size;
    (litm+1)->item = 1;
    (litm+1)->pact = &afun;

    (litm+2)->xsize = 22;
    (litm+2)->ysize = 10;
    (litm+2)->xorg = 54;
    (litm+2)->yorg = 2;
    (litm+2)->type = 2;
    (litm+2)->skey = K_WAKE;
    (litm+2)->pobj = &mes_wake;
    (litm+2)->item = 2;
    (litm+2)->pact = &afun;

    (litm+3)->xsize = 22;
    (litm+3)->ysize = 10;
    (litm+3)->xorg = INIWID - 38;
    (litm+3)->yorg = 2;
    (litm+3)->skey = K_CANCEL;
    (litm+3)->pobj = &END;
    (litm+3)->item = 3;
    (litm+3)->pact = &aexit;

    (litm+4)->xsize = 2;
    (litm+4)->ysize = 2;
    (litm+4)->type = 2;
    (litm+4)->skey = K_TAB;
    (litm+4)->pobj = &mes_null;
    (litm+4)->item = 4;
    (litm+4)->pact = &mbars;

    (litm+5)->xsize = (litm+5)->ysize = -1;

    aw0 = qmalloc(sizeof(WM_menw_t));

    aw0->xsize = INIWID;
    aw0->ysize = ysz;
    aw0->yorg = 14;
    aw0->borw = 1;
    aw0->borc = 4;
    aw0->draw = &adraw;
    aw0->hit = &ahit;
    aw0->ctrl = &actrl;
    aw0->nysc = 1;
    aw0->xinsp = 1;
    aw0->xpsac = 4;
    aw0->xpsbc = 2;
    aw0->xpssc = 7;
    aw0->ypwcb = qmalloc(sizeof(WM_pwcb_t));
    aw0->yinsz = 1;
    aw0->yinsp = 1;
    aw0->yiciw = 1;
    aw0->yicic = 1; 
    aw0->ypsac = 0;
    aw0->ypsbc = 2;
    aw0->ypssc = 7;

    appl = qmalloc(sizeof(WM_appl_t)*(NAPPL+2));

    (appl+0)->pappw = (WM_appw_t *) aw0;
    (appl+1)->pappw = NULL;
    (appl+2)->pappw = (WM_appw_t *) c;
 
    wsc = qmalloc((6+2*(NINFW+NINFO+NLITM+NAPPL))*sizeof(short));
    wsc->xmin = 220;
    wsc->ymin = 94;
    wsc->xinc = 12;
    wsc->yinc = 10;
    wsc->s8[0][0] = 8; /* infw[0], x scale */
    wsc->s8[1][2] = 4; /* infw[1], centre  */
    wsc->s8[6][2] = 8;
    wsc->s8[8][0] = wsc->s8[8][1] = 8;

    ws = qmalloc(sizeof(WM_wstat_t));
    ws->wmode = FORM_QL4;
    ws->citem = -1;
    
    ysz += 14;

    ww = qmalloc(sizeof(WM_wwork_t));

    ww->wstat = ws;
    ww->wscale = (WM_wscale_t *) wsc;
    ww->splst = appl;
    ww->xsize = INIWID;
    ww->ysize = ysz;
    ww->xorg = 4;
    ww->yorg = 16;
    ww->flag = NO_WCLEAR;
    ww->borw = 1;
    ww->borc = 4;
    ww->papr = 7;
    ww->curw = 1;
    ww->uback = 3;
    ww->uink = 7;
    ww->aback = 7;
    ww->sback = 4;
    ww->ninfo = NINFW;
    ww->ninob = NINFO;
    ww->pinfo = infw;
    ww->nlitm = NLITM;
    ww->plitm = litm;
    ww->nappl = NAPPL;
    ww->pappl = appl;
};

static void MovePtr(WM_wwork_t *wwk)
{
    int key;
    short x, y;
    WM_menw_t *apw = (WM_menw_t *)(wwk->pappl+0)->pappw;
    CAPDEF_t *c = (CAPDEF_t*)(wwk->pappl+2)->pappw;

    extern setptr (int, int, short *, short *, int);

    if (c->DoAct == 'G')
    {
	x = c->lx;
	y = c->ly;
	key = 0;
    }
    else
    {
	short tmp;
        x = apw->xsize + XBARS/4;
        tmp = (apw->ypwcb->s[0].siz > apw->nrow) 
	    ? apw->nrow : apw->ypwcb->s[0].siz;
        y = ((int) ((apw->ypwcb->s[0].stt + tmp / 2) * apw->ysize)) / apw->nrow;
        key = -1;
    }
    setptr (c->revid, -1, &x, &y, key);
    c->DoAct = 0;
}

char *GetCapData(CAPDEF_t *c)
{
    PLEMT pl, pn = NULL;
    int i;
    char *ptr;

    c->iline = 0;

    pl = c->pHead = (PLEMT) xmalloc (sizeof (LEMT));

    mt_susjb(SerJID, -1, NULL);

    c->msize = (c->wrap) ? c->max : c->size;

    if((c->RevPtr = qmalloc(c->msize)) != NULL)
    { 
        if(c->wrap == 0)
        {
            memcpy(c->RevPtr, c->buf, c->msize);
        }
        else
        {
            int mnext, n;

            mnext = c->size + 1;
            if(mnext == c->max)
            {
                mnext = 0;
            }
            memcpy(c->RevPtr, c->buf + mnext, (n = c->max - mnext));
            memcpy(c->RevPtr + n, c->buf, mnext); 
        }

        c->pHead->fpos = ptr = c->RevPtr;
	
        for (c->NLine = i = 0; i < c->msize ; i++, ptr++)
        {
	    if(*ptr == 13 && bRXEOL == EOLCR)
	    {
		*ptr = 10;
	    }
	    if (*ptr == 10 || i == c->msize-1)
	    {
	        c->NLine++;
	        pn = (PLEMT) xmalloc (sizeof (LEMT));
	        pn->next = NULL;
	        pn->fpos = ptr + 1;
	        pl->next = pn;
	        pl = pn;
	    }
        }
    }
    c->TopL = 0;
    mt_reljb(SerJID);
    return c->RevPtr;
}

FreeCapData (CAPDEF_t *c)
{
    PLEMT pl, pn;
    
    for (pl = c->pHead; pl;)
    {
	pn = pl;
	pl = pl->next;
	xfree (pn);
    }

    xfree(c->RevPtr);
}    
#ifdef SIGS
static void sigu1(int sig)
{
    signal(sig, sigu1);
}
#endif 
ReviewBuffer (CAPDEF_t *c)
{
    struct WM_wsiz wl;
    static short lx = -1,ly = -1;
    WM_wwork_t *wwk;
    WM_appw_t *apw;
    int (*func)(WM_wwork_t *,...);
    long vers;
    long sts;
#ifdef SIGS    
    _Signals_Init();
    signal(SIGUSR1, sigu1);
#endif
    if((wwk = NewWindow(c)))
    {
	apw =  = (wwk->pappl+0)->pappw;

	wwk->chid = io_open("scr", 0);

	if((sts = (long)iop_pinf(wwk->chid, -1, &vers)) <= 0)
	{
	    QErr ("iop_pinf failed, report to jrhudson@bigfoot.com", sts);
	    return -1;
	}

	iop_flim(wwk->chid, -1, &wl);
	
	wwk->wscale->xmax = 8 + ((wl.xsize - 12)/6) * 6;
	wwk->wscale->ymax = 14 + ((wl.ysize - 16)/10) * 10;
	
	if(lx == -1 && ly == -1)
	{
	    lx = (wl.xsize - wwk->xsize)/2;
	    ly = (wl.ysize - wwk->ysize)/2;
	}
	
	c->Quit = 0;
	c->revid = io_open ("scr", 0);
	
	apw->xsize = wwk->xsize;
    
/*
 * Now create a linked list
 * of pointers to start of lines
 */
	if(mono)
	{
	    (wwk->pinfo+0)->papr = 127;
	    apw->borc = 7;
	    wwk->borc = 7;
	}

	GetCapData(c);
	if(c->RevPtr == NULL)
	{
	    OutError ("Eeeks -- CapData is NULL, report to jrhudson@bigfoot.com", sts);
	    return -1;
	}
	
/*
 * Prime the part window control block
 */
	apw->ypwcb->nsec = 1;
	apw->ypwcb->s[0].pos = 0;
	apw->ypwcb->s[0].stt = 0;
	
/*
 * Draw the window, the wm_wdraw action routine will display the first
 * page and the scroll bars
 */
	
	wm_prpos (wwk, c->lx, c->ly);
	wm_wdraw (wwk);
/*
 * The reason for Quit == 0 is that I use a varient of this program
 * as a procedure for a pull down window text viewer (just wait for the
 * QTPI v1.x "review buffer" feature). In the procedure version we need
 * to tidy up ourself, rather than relying on QDOS to do it for us.
 */

	while (wm_rptr(wwk), c->Quit == 0)
	{
	    if (wwk->wstat->evnt & PT_WAKE)
	    {
		FreeCapData(c);
		GetCapData(c);
		sd_clear(c->revid, -1);
		apw->xsize +=8;              /* ready for re-draw */
		ADRAW(wwk, (struct WM_appw *) apw);
		lit_reset (wwk, 2);
	    }
	    
	    if (wwk->wstat->evnt & PT_WSIZE)
	    {
		apw->xsize +=8;              /* ready for re-draw */
		re_size (wwk, 1, 0);
	    }
	    
	    /*
	     * This bit to work out how much to scroll etc is really messy, I'm
	     * not proud of it, there must be a better way to do it, but it's a
	     * PTR example, not a nice 'C' example....
	     */
	    
	    if (wwk->wstat->evnt & PT_DO)
	    {
#ifdef SIGS
		if(c->flag)
		{
		    FreeCapData(c);
		    GetCapData(c);
		    sd_clear(c->revid, -1);
		    apw->xsize +=8;              /* ready for re-draw */
		    ADRAW(wwk, (struct WM_appw *) apw);
		    c->flag = 0;
		}
		else
#endif
		    if(c->DoAct)
		    {
			MovePtr(wwk);
		    }
		    else if (c->iline > 0)
		    {
			int xb;
			
			xb = c->BotL;
			if (c->BotL + c->iline >= c->NLine)
			{
			    c->iline = c->NLine - c->BotL;
			    c->TopL = c->NLine - c->maxline;
			    c->BotL = c->NLine;
			}
			else
			{
			    c->TopL += c->iline;
			    c->BotL += c->iline;
			}
			
			if (c->BotL != xb)
			{
			    /*
			     * Why not TopL * ysize / NLine ?????
			     * What does wm_upbar do (nothing ??)
			     */
			    
			    apw->ypwcb->s[0].stt = c->TopL;
			    wm_upbar (wwk, (struct WM_swdef *) apw, 0, 0);
			    if (c->iline > c->maxline)
			    {
				c->iline = c->maxline;
				sd_pos (c->revid, -1, 0, 0);
				sd_clear (c->revid, -1);
			    }
			    else
			    {
				sd_scrol(c->revid, -1, -10);
				sd_pos(c->revid, -1, 0, c->maxline-1);
			    }
			    DoText (wwk, c->BotL - c->iline, c->BotL);
			}
		    }
		    else if (c->iline < 0 && c->TopL)
		    {
			int xt;
			int ml;
			
			xt = c->TopL;
			if (c->TopL + c->iline <= 0)
			{
			    ml = c->TopL;
			    c->TopL = 0;
			    c->iline = -ml;
			    c->BotL = c->maxline;
			}
			else
			{
			    ml = c->TopL;
			    c->TopL += c->iline;
			    c->BotL += c->iline;
			}
			
			if (c->TopL != xt)
			{
			    apw->ypwcb->s[0].stt = c->TopL;
			    wm_upbar (wwk, (struct WM_swdef *) apw, 0, 0);
			    c->iline = -c->iline;
			    if (c->iline > c->maxline)
			    {
				c->iline = c->maxline;
				sd_pos (c->revid, -1, 0, 0);
				sd_clear (c->revid, -1);
				DoText(wwk, c->TopL, c->BotL);
			    }
			    else
			    {
				int i;
				for (i = 0; i < c->iline; i++)
				{
				    sd_pos (c->revid, -1, 0, 0);
				    sd_scrol (c->revid, -1, 10);
				    DoText (wwk, ml - i - 1, ml - i);
				}
			    }
			}
		    }
	    }
	}

	wwk->xorg = wwk->wstat->ptpsx - wwk->xorg;
	wwk->yorg = wwk->wstat->ptpsy - wwk->yorg;
	c->lx = wwk->wstat->ptpsx;
	c->ly = wwk->wstat->ptpsy;
	
	io_close (c->revid);
	wm_cluns (wwk);
    }
    else
    {
	exit(-15);
    }
    FreeCapData (c);
    c->revid = 0;    
    c->child = 0;
    return (0);
}

/*
 * Get a pointer to a line number in the linked list of lines
 */

char * GetPos (PLEMT pHead, int pos)
{
    PLEMT pl;
    int i;

    for (pl = pHead, i = 0; i < pos && pl; pl = pl->next, i++)
	;
    return pl->fpos;

}

/*
 * Display text between top line (tl) and bottom (bl)
 */
 
static DoText (struct WM_wwork * wwk, int tl, int bl)
{
    int j;
    char * sp, * ep, * p;
    WM_menw_t *apw = (WM_menw_t *)(wwk->pappl+0)->pappw;
    CAPDEF_t *c = (CAPDEF_t *) (wwk->pappl+2)->pappw;
    
    sp = GetPos (c->pHead, tl);
    ep = GetPos (c->pHead, bl);

    ShowPct(wwk);

    for (j = 0, p = sp; p < ep  ; p++)
    {
	if (*p == 10)
	{
	    j = 0;
	    io_sbyte (c->revid, -1, *p);
	}
	else if (*p != 13)
	{
            /*
             * No wrap at edge
             */
            
	    if (j < apw->xsize / 6)
	    {
		io_sbyte (c->revid, -1, *p);
	    }
	    j++;
	}
    }
}
/*
 * Show percentage in title bar
 */
static ShowPct(struct WM_wwork *wwk)
{
    WM_menw_t *apw = (WM_menw_t *)(wwk->pappl+0)->pappw;
    CAPDEF_t *c = (CAPDEF_t*) (wwk->pappl+2)->pappw;
    int pct;
    char ptxt[8];
    short ns;

    pct = c->BotL * 100 / c->NLine;
    sprintf(ptxt, "%3d%%", pct);
    wm_swinf(wwk, (short)1, 0);
    ns = strlen(c->name);
    ns = (ns+2) * 6;
    sd_pixp(wwk->chid, -1, ns, 0);
    sd_clrrt(wwk->chid, -1);
    io_sstrg(wwk->chid, -1, ptxt, (short) 4);
}

static long AEXIT (struct WM_wwork *wwk, struct WM_litm *li)
{
    WM_menw_t *apw = (WM_menw_t *)(wwk->pappl+0)->pappw;
    CAPDEF_t *c = (CAPDEF_t*) (wwk->pappl+2)->pappw;

    lit_reset (wwk, li->item);
    c->Quit = 1;
    return PT__DO;
}

/*
 * Draw action routine
 * n.b. makes room for scroll bars (8 pixels)
 */

static long ADRAW (struct WM_wwork *wwk, struct WM_appw *wptr)
{
    int addon;
    CAPDEF_t *c = (CAPDEF_t*) (wwk->pappl+2)->pappw;
    WM_menw_t * apw = (WM_menw_t *)wptr; 
    apw->xsize -= 8;
    
/*
 * Initial guess at scroll bar size
 * why this difficult ?
 */

    c->maxline = apw->ysize / 10;
    apw->ypwcb->s[0].siz = c->maxline;
    addon = (c->NLine > c->maxline) ? c->maxline : c->NLine;
    c->BotL = c->TopL + addon; 
    if(c->BotL > c->NLine)
    {
        c->BotL = c->NLine;
        c->TopL = c->BotL - c->maxline;
    }

    apw->ypwcb->s[0].stt = c->TopL;
    apw->nrow = c->NLine;
    wm_index (wwk, (struct WM_swdef *) apw);
    wm_swdef (wwk, (WM_appw_t *) apw, c->revid);
    sd_setin(c->revid, -1, (mono) ? 7 : 4);
    DoText (wwk, c->TopL, c->BotL);
    return 0;
}

/*
 * Hit routine, calculate displacement (iline) and set a DO event
 * (From a keystroke in window event)
 */
 
static long AHIT (struct WM_wwork *wwk, struct WM_appw *apw,
		  struct WM_wstat *wst, short x, short y, short evnt)
{
    CAPDEF_t *c = (CAPDEF_t *)(wwk->pappl+2)->pappw;

    switch (evnt)
    {
        case 1:
	    c->iline = 1;
            break;
        case 2:
        case 0xd9:
            c->iline = apw->ysize / 10 - 1;
            break;
        case 0xd1:
            c->iline = -apw->ysize / 10 + 1;
            break;
        case 0xfc:
    	    c->iline = -1;
            break;
        case 'B':
            c->iline = c->NLine-c->TopL;    
            break;
        case 'T':
            c->iline = -c->TopL;    
            break;
        default:
            c->iline = 0;
            break;
    }
    if (c->iline)
    {
	wwk->wstat->evnt |= PT_DO;
    }
#ifdef SIGS
    if (c->flag)
    {
	wwk->wstat->evnt |= PT_DO;
    }
#endif
    return AHIT_NORMAL;
}
/*
 * Ctrl routine, calculate displacement (iline) and set a DO event
 * From a hit on the scroll bars.
 */
static long ACTRL (struct WM_wwork *wwk, struct WM_appw *apw,
		   struct WM_wstat *wst,
		   short bpos, short blen, short item, short evnt)
{
    int x;
    char txt[64];
    CAPDEF_t *c = (CAPDEF_t *) (wwk->pappl+2)->pappw;

    x = c->NLine * bpos / blen;
    c->iline = x - c->TopL;
    return PT__DO;
}
/*
 * On the move, must redraw the window
 */

static long MMOVE(wwk) struct WM_wwork *wwk;
{
    short dx,dy;
    WM_appw_t *apw = (wwk->pappl+0)->pappw;
    CAPDEF_t *c = (CAPDEF_t *)(wwk->pappl+2)->pappw;
    wwk->wstat->evnt |= PT_WMOVE;   /* set event bit for wm_chwin */
    wm_chwin (wwk,&dx,&dy);         /* move window */
    wm_swdef (wwk, apw, c->revid);
    return lit_reset (wwk, 0); /* and return */
}

static long MBARS (struct WM_wwork *wwk, struct WM_litm *li)
{
    short ix, inx;
    WM_appw_t *apw = (wwk->pappl+0)->pappw;
    CAPDEF_t *c = (CAPDEF_t *)(wwk->pappl+2)->pappw;;

    ix = wwk->xorg + wwk->xsize - wwk->wstat->ptpsx;
    inx = (ix >= 0 && ix < XBARS);

    if(li->item == 4)
    {
        if(inx)
        {
            c->DoAct = 'G';
	}
        else
        {
            c->lx = wwk->wstat->ptpsx;
            c->ly = wwk->wstat->ptpsy;
            c->DoAct = 'T';
        }
    }
    return PT__DO;
}
