/*
 * $Log: xprstuff.c,v $
 * Revision 1.10  1998/06/12 20:03:01  jrh
 * Fixed -i bug
 *
 * Revision 1.9  1997/08/23 21:13:39  jrh
 * pre config removal
 *
 * Revision 1.8  1997/04/13 16:54:18  jrh
 * cursor and console changes
 *
 * Revision 1.7  1996/12/23 22:33:04  jrh
 * Checkin for 1.62
 *
 * Revision 1.6  1996/07/09  12:25:57  jrh
 * post fsel (1.60)
 *
 * Revision 1.5  1996/07/09  09:26:15  jrh
 * pre file sel (1.599)
 *
 * Revision 1.4  1996/01/19  13:23:56  root
 * Revised for 1.57
 *
 * Revision 1.3  1995/12/30  18:28:09  root
 * For v1.57 (QXL baud, SH status, CSM crash)
 *
 * Revision 1.2  1995/11/12  15:29:37  root
 * Baud rates for QXL etc
 *
 * Revision 1.1  1995/09/16  17:22:18  root
 * Initial login under Linux
 *
 * Revision 1.14  1995/04/17  22:00:45  jrh
 * Things & fix local lockup
 *
 * Revision 1.13  1995/04/08  20:53:27  jrh
 * Add Thing functionality
 *
 * Revision 1.12  1995/03/31  12:21:52  jrh
 * Fix mallocs to use xmalloc
 *
 * Revision 1.11  1995/03/27  21:58:47  jrh
 * Change spawn for better channel definition
 *
 * Revision 1.10  1995/03/24  16:29:31  jrh
 * New job code & XPR BAse
 *
 * Revision 1.9  1995/03/18  12:53:37  jrh
 * Change XPR base version no
 *
 * Revision 1.8  1995/03/18  12:15:37  jrh
 * C68 v4.5
 *
 * Revision 1.7  1995/03/13  22:13:34  jrh
 * Added init/exit scripting
 *
 * Revision 1.6  1995/03/12  23:00:08  jrh
 * scripting
 *
 * Revision 1.5  1995/02/07  16:52:32  jrh
 * better wild cards etc
 *
 * Revision 1.4  1994/12/25  13:41:44  jrh
 * Don't upload NULL filenames
 *
 * Revision 1.3  1994/12/15  21:31:12  jrh
 * set file name for ZMODEM
 *
 * Revision 1.2  1994/05/31  22:19:55  jrh
 * c68 v4.13c fixes
 *
 * Revision 1.1  1994/05/30  21:43:30  jrh
 * Initial checkin at v1.33
 *
 */

static char rcsid[] = "$Id: xprstuff.c,v 1.10 1998/06/12 20:03:01 jrh Exp $";

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <signal.h>
#include <qdos.h>
#include <qptr.h>
#include "wild.h"

typedef struct mitem
{
    short len;
    char chrs[1];
}
MITEM, *PMITEM;

#include <pd/xproto.h>
#include "defs.h"
#include "xprmsg.h"

#define PIPEOK(p1) (p1) > 0

extern PXPRTHG pXB;

Local int AddXMenu (PLLIST *, char *);
Prototype BuildXMenu (PLLIST *);
Prototype int XPRFind (FLIST **);
Prototype FreeXList (PLLIST *);
Prototype XPRUse (char *);
Prototype XPRKill ();
Prototype DoXPROptions (struct WM_wwork *);
Prototype XPRIO (void *f, int dirn);
Prototype int SXPRIO (struct WM_wwork *wwk, char *name);
Prototype AutoXPR (struct WM_wwork *, int);
Prototype int XPRMon (unsigned char ch);
Prototype int XPRTidy (int res, int n);
Prototype char *FindXPRExe (char *);

Local AutoSend (struct WM_wwork *);

static int IPipe = -1;
static int OPipe = -1;

static char *rbuf = "*\030B0x";
static char *abuf;

extern struct WM_wwork *Main_ww;
extern char *GetScriptLog (void);
extern void vStartMBJob (char *, char *, char *, int, int,...);

int SpawnScript (char *sname, short timo, char *cmd)
{
    SJOB s;

    s.FileName = sname;
    s.ComStr = cmd;
    s.InFile = (char *) -1;
    s.inflag = -1;
    s.OuFile = GetScriptLog ();
    s.ouid = 0;
    s.serr = 0;
    s.Wait = timo;
    s.Prio = 1;
    s.JobId = -1;
    return spawn (&s);
}

extern char *FullName (char *name, char *myname);
extern int TryThing (char *thing, char *cmd, short timo, void **, int,...);

int RunScript (char *QName, short timo, char *cmd)
{
    struct qdirect qd;
    int rv = -1;
    char *pf, fn[64];
    const void *ph = NULL;

    if (*QName == '*')
    {
	pf = FullName (QName + 1, fn + 1);
	*(--pf) = '*';
	rv = TryThing ("cli", pf, timo, &ph, 0);
    }
    else
    {
	rv = TryThing (QName, cmd, timo, &ph, 0);
	if (ph == NULL)
	{
	    pf = FullName (QName, fn);

	    if (qstat (pf, &qd) == 0)
	    {
                int pn = strlen(pf);
                
		if (qd.d_type == QF_PROG_TYPE)
		{
		    if (SpawnScript (pf, timo, cmd) == 0)
		    {
			rv = 0;
		    }
		}
		else if (pn > 4 && (*(pf+pn-4) == '_' || *(pf+pn-4) == '.')
                         && stricmp("bas",pf+pn-3) == 0)
		{
                    if (minnie)
		    {
			vStartMBJob ("QTPI Script", pf, cmd, timo, -1);
			rv = 0;
		    }
		    else
		    {
		        rv = TryThing("sbasic", cmd, timo, &ph, -1, pf);
		    }
		}
	    }
	}
    }
    return rv;
}

static AddXMenu (PLLIST * pX, char *q)
{
    PMITEM s;
    PMDEF pm;
    PLLIST pl;
    short n;

    n = strlen (q);
    s = (MITEM *) xmalloc (n + 8);
    s->len = n;
    strcpy (s->chrs, q);
    pm = (PMDEF) xmalloc (sizeof (MDEF));
    pm->qtext = (struct QD_text *) s;
    pm->status = WSI_AVBL;
    pm->retval = 0;
    pm->action = NULL;
    if (*q != '(')
    {
	pm->skey = -1;
    }
    pl = (PLLIST) xmalloc (sizeof (LLIST));
    pl->item = pm;
    pl->next = NULL;
    ins_list (pX, pl, CompareMenu);
}
BuildXMenu (PLLIST * pX)
{
    char *p;
    int n;
    PLLIST pl;
    FLIST *xl, *fl = NULL;

    OutError ("Searching for XPR Libraries");

    n = XPRFind (&fl);
    if (n > 0)
    {
	AddXMenu (pX, "(None)");

	for (xl = fl; xl; xl = xl->next)
	{
	    char *q, *r;

	    for (q = xl->text; (r = strstr (q, "xpr")); q = r + 3)
		;		/* Find last */

	    if (q && *q)
	    {
		if ((r = strchr (q, '_')))
		{
		    *r = '\0';
		}
		else if ((r = strchr (q, '.')))
		{
		    *r = '\0';
		}

		strupr (q);
		AddXMenu (pX, q);
	    }
	}
#if 0
	pl = (*pX)->next;
	for (pl, n = 0; pl; pl = pl->next, n++)
	{
	    PMDEF pm;
	    char c;

	    pm = (PMDEF) pl->item;

	    if (n < 10)
	    {
		c = n + 48;
	    }
	    else if (n > 9 && n < 36)
	    {
		c = n + 55;
	    }
	    else
	    {
		c = ' ';
	    }
	    pm->skey = (c == ' ') ? 0 : -1;
	    *(((PMITEM) pm->qtext)->chrs) = c;
	}
#endif
	n++;			/* for first one */
    }
    else
    {
	OutError ("Can't find any XPR Libraries");
	n = 0;
    }
    FreeWildList (&fl);
    return n;
}

int XPRFind (FLIST ** pfl)
{
    char *ePtr;
    char WildXPR[64];

    if ((ePtr = getenv ("XPR_PATH")) == NULL)
    {
	if (*LibDir)
	{
	    ePtr = LibDir;
	}
	else
	{
	    ePtr = "";
	}
    }

    strcat (strcpy (WildXPR, ePtr), "xpr*library");

    return ScanDir (WildXPR, pfl, 0);
}

FreeXList (PLLIST * pL)
{
    PLLIST p;

    for (p = *pL; p;)
    {
	PMITEM s;
	PMDEF pm;
	PLLIST pd;

	pd = p;
	p = p->next;
	pm = (PMDEF) pd->item;
	s = (PMITEM) pm->qtext;
	xfree (s);
	xfree (pm);
	xfree (pd);
    }
    *pL = NULL;
}

static int myaccess (char *p, int mode)
{
    int cn;
    int rv = -1;
    struct qdirect buf;

    if ((cn = io_open (p, 0)) > 0)
    {
	if (mode == 1)
	{
	    if (fs_headr (cn, -1, &buf, sizeof (buf)) > 0)
	    {
		if (buf.d_type)
		{
		    rv = 0;
		}
	    }
	}
	else
	{
	    rv = 0;
	}
	io_close (cn);
    }
    return rv;
}

char *FindXPRExe (char *pName)
{
    static char ExeName[64];
    char *ePtr;
    int rv;

    if ((ePtr = getenv ("XPR_PATH")) == NULL)
    {
	if (*LibDir)
	{
	    ePtr = LibDir;
	}
	else
	{
	    ePtr = "";
	}
    }

    sprintf (ExeName, "%sxpr%s_library", ePtr, pName);
    if (rv = myaccess (ExeName, 1))
    {
	sprintf (ExeName, "%sxpr%s.library", ePtr, pName);
	rv = myaccess (ExeName, 1);
    }

    if (rv == 0)
    {
	return ExeName;
    }
    else
    {
	return NULL;
    }
}

XPRUse (char *pName)
{
    int n, val = 0;
    SJOB s;
    short msgno;
    int xstat;

    memset (&s, '\0', sizeof (SJOB));

    if (XPRPid > 0)
    {
	XPRKill ();
    }

    if (pName && *pName && strncmp (pName, "(None)", 6))
    {
        char mbuf[16];
        sprintf(mbuf, "%x\r", pXB);
	OutError ("Loading XPR%s Library ....", pName);
	abuf = rbuf;
	OPipe = io_open ("pipe_16", 0);

	s.FileName = FindXPRExe (pName);

	s.ComStr = mbuf;
	s.InFile = "pipe_0";
	s.inflag = OPipe;
	s.OuFile = "pipe_16";
	s.ouid = 3;
	s.serr = pChId;
	s.Wait = 0;
	s.Prio = QT.Zprio;
	s.JobId = -1;

	if ((xstat = spawn (&s)) == 0)
	{
#define BASE_XPR "3.49"
            ALIGN x;
            static ALIGN xv = {BASE_XPR};

	    XPRPid = s.JobId;
	    IPipe = io_open ("pipe_0", s.ouid);

	    msgno = XMSG_START;

	    io_sstrg (OPipe, -1, (char *) &msgno, 2);
	    n = io_fstrg (IPipe, -1, (char *) &x.txt, 4);

/*            Report(("Load XPR %d %08x %08x\n", n, x.x, xv.x));*/
            
	    if (x.x >= xv.x && n == 4)
	    {
		val = pXB->status;
	    }
	    else
	    {
		xstat = -1;
		OutError ("Incompatible XPR Library");
	    }
	}
	else
	{
	    OutError ("Can't load XPR Library");
	}
	if (xstat != 0)
	{
	    XPRKill ();
	    *MyProtocol = '\0';
	    val = 0;
	}
    }
    return val;
}

XPRKill ()
{
    if (XPRPid > 0)
	mt_frjob (XPRPid, -1);
    if (IPipe > 0)
	io_close (IPipe);
    if (OPipe > 0)
	io_close (OPipe);
    IPipe = OPipe = XPRPid = 0;
}


DoXPROptions (struct WM_wwork *wwk)
{
    short msgno;
    int res, n;
    struct xpr_option *pxopt;
    int nopt;

    msgno = XMSG_SETUP;

    n = io_sstrg (OPipe, -1, (char *) &msgno, 2);
    if (PIPEOK (n))
    {
	n = io_fstrg (IPipe, -1, (char *) &msgno, 2);
	if (PIPEOK (n))
	{
	    do
	    {
		if (msgno == XMSG_SETDATA)
		{
		    pxopt = (struct xpr_option *) pXB->buf;
		    nopt = pXB->size;
		    pXB->status = XPROptions (wwk, pxopt, nopt);
		    msgno = XMSG_STATUS;
		    io_sstrg (OPipe, -1, (char *) &msgno, 2);
		}
		n = io_fstrg (IPipe, -1, (char *) &msgno, (short) 2);
		if (msgno == XMSG_STATUS)
		{
		    res = pXB->status;
		}

	    }
	    while (msgno != XMSG_STATUS && n > 0);
	}
    }
    XPRStatus = XPRTidy (res, n);
}

int XPRTidy (int res, int n)
{

    Blocked = 0;
    if(pS->Pid)
    {
	mt_reljb (SerJID);
	mt_prior (pS->Pid, QT.Sprio);
    }
    
    if (n <= 0)
    {
	XPRKill ();
	*MyProtocol = '\0';
	OutError ("XPR Error on command");
	res = -1;
    }
    else
    {
	mt_prior (XPRPid, QT.Zprio);
    }
#ifdef SIGS
    if(Xfr.child)
    {
	Xfr.flag = 1;
	if(kill (Xfr.child, SIGUSR1))
	{
	    extern void _SigNoImp(void);
	    _SigNoImp();
	}
    }
#endif
    return res;
}
static char *ExtractFile (char *pat, short *pflag, short *recurse)
{
    static int fchid = 0;
    char *p, *q;
    static char text[64];

    if (fchid > 0)
    {
	int n;

	n = io_fline (fchid, -1, text, 64);
	if (n > 0)
	{
	    if ((p = strchr ((q = text), '\n')))
	    {
		*p = '\0';
	    }
	    if (*text == '-' && *(text + 1) == 'r')
	    {
		*recurse = 1;
		q = stpblk (text + 2);
	    }
	}
	else
	{
	    io_close (fchid);
	    fchid = 0;
	    /*
	     * Recursion: see recursion etc
	     */
	    q = ExtractFile (pat, pflag, recurse);
	}
    }
    else
    {
	q = strtok ((*pflag) ? NULL : pat, " ,\t");
	(*pflag)++;
	if (q && *q == '@')
	{
	    fchid = io_open (q + 1, 0);
	    q = ExtractFile (pat, pflag, recurse);
	}
	else if (q && *q == '-' && *(q + 1) == 'r')
	{
	    *recurse = 1;
	    q = ExtractFile (pat, pflag, recurse);
	}
    }
    return q;
}

static FLIST *xfl = NULL;

int MakeFileList (char *pat)
{
    static char *wild = "*?!";
    short recurse;
    char *p, *q;
    int n, totl = 0;
    short Done, k;

    if (xfl)
    {
	FreeWildList (&xfl);
    }

    for (Done = k = 0; !Done;)
    {
	recurse = 0;
	if ((p = ExtractFile (pat, &k, &recurse)) == NULL)
	{
	    Done = 1;
	    continue;
	}
	else if (strpbrk (p, "*?") == NULL)
	{
	    AddFile (&xfl, p);
	    totl++;
	}
	else
	{
	    n = ScanDir (p, &xfl, recurse);
	    totl += n;
	}
    }
    return totl;
}


XPRIO (void *f, int dirn)
{
    int msg, flag;
    short sx, sy;

    if(csr)
    {
	PosNull;
    }
    if (XPRPid > 0)
    {
	if (dirn == SEND || dirn == RECEIVE)
	{
	    if (Blocked == 0)
	    {
		Blocked = 1;
	    }
	    if (dirn == SEND)
	    {
		if (f == NULL)
		{
		    f = xfl;
		}
		flag = 0;
		msg = XMSG_SEND;
	    }
	    else
	    {
		msg = XMSG_RECV;
		if(!(dbflag & 6))
		{
		    flag = 1;
		    mt_prior (pS->Pid, QT.Sprio * 2);
/*		    mt_prior (XPRPid, ((hflag) ? 32 : QT.Zprio)); */
		}
		else
		{
		    flag = 0;
		}
	    }
	    if(flag == 0)
	    {
		if(pS->Pid)
		    mt_prior (pS->Pid, 0);
		mt_prior (XPRPid, 32);
	    }
	    
	    mt_prior (-1, 1);
	    InitXWindow (f, IPipe, OPipe, msg, flag);
	    mt_prior (-1, QT.Qprio);
	    DoStatus ();
	    MakePoint ();
	}
    }
    if (csr)
    {
	PosText ();
    }
    if (xfl)
    {
	FreeWildList (&xfl);
    }
}
int XPRMon (unsigned char ch)
{
    char match, b;
    int k;
    static char Act = -1;
    int rval = 0;

    if (*abuf == 'x')
    {
	match = 0;
	if (ch >= '0' || ch <= '9')
	{
	    Act = ch;
	    match = 1;
	}
    }
    else
    {
	match = (ch == *abuf);
    }

    if (match)
    {
	abuf++;
	if (*abuf == '\0')
	{
	    while ((*pS->ReadQue) (2, &b, 1, &k) == 0)
		;
	    if (Act == '0')
	    {
		rval = RECEIVE;
	    }
	    else if (Act > '0' && Act <= '9')
	    {
		rval = SEND;
	    }
	    abuf = rbuf;
	    Act = -1;
	}
    }
    else
    {
	abuf = rbuf;
	Act = -1;
	if (ch == *abuf)
	{
	    abuf++;
	}
    }
    return rval;
}

int SXPRIO (struct WM_wwork *wwk, char *name)
{
    int opt;

    if (MakeFileList (name) > 0)
    {
	XPRIO (xfl, SEND);
	opt = 0;
    }
    else
    {
	menu_choice (wwk, "No Files found", 1, 0, "OK");
	opt = -1;
    }
}
AutoXPR (struct WM_wwork *wwk, int dirn)
{
    if (dirn == RECEIVE)
    {
	XPRIO (NULL, RECEIVE);
    }
    else if (dirn == SEND)
    {
	AutoSend (wwk);
    }
}

extern short iconic;

static AutoSend (struct WM_wwork *wwk)
{
    int nopt=-1, rval;
    char b;
    int k;
    static char *prompt = "Auto ZModem Upload";
    
    static char canit[] =
    {
    '*', '*', 24, 24, 24, 24, 24, 24, 24, 24, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 0
    };

    if(!iconic)
    {
	
	nopt = menu_choice (wwk, prompt, 2, 0, "Request files", "Abort");
	if (nopt == 0)
	{
	    if(useFS)
	    {
		GetMenuFile(prompt, XmRFile, BaseName);
	    }
	    else
	    {
		nopt = menu_text (wwk, prompt, BaseName, 40);
	    }
	    
	    if (nopt != -1)
	    {
		while ((*pS->ReadQue) (2, &b, 1, &k) == 0)
		    ;
		nopt = SXPRIO (wwk, BaseName);
		rval = 1;
	    }
	}
    }

    if (nopt)
    {
	(*pS->SendStr) (canit);
	rval = 0;
    }
    DoStatus ();
    return rval;
}
